<?php
if ( ! class_exists( 'IPTrac_Shortcode' )) {

    /**
     * Class for processing shortcode
     */
    class IPTrac_Shortcode
    {
        /**
         * Get troubleshooter content
         *
         * @param  array  $atts
         * @param  string $content
         * @return void
         */
        public function troubleshooter( $atts, $content = '')
        {
            $args = array(
                'post_type' => 'troubleshooter'
            );
            $troubles = new WP_Query( $args );
            if( $troubles->have_posts() ) {
            ?>
                <div class="iptrouble-list">
                <?php
                while( $troubles->have_posts() ) {
                    $troubles->the_post();
                    ?>
                        <div class="iptrouble-item">
                            <h2 class="iptrouble-title">
                                <a href="<?php the_permalink(); ?>"><?php the_title() ?></a>
                            </h2>
                            <div class='iptrouble-content'>
                                <?php the_excerpt() ?>
                            </div>
                        </div>
                    <?php
                }
                ?>
                </div>
             <?php 
            }
            else {
                _e( 'Troubleshooter no available', 'wpiptrac' );
            }
        }
        
        /**
         * Get knowledge content
         *
         * @param  array  $atts
         * @param  string $content
         * @return void
         */
        public function knowledge( $atts, $content = '')
        {
            ?>
            <ul class="ip-knowledge-list">
            <?php
            wp_list_categories( array( 
                'taxonomy'  => 'knowledge_category',
                'title_li'  => '',
            ) );
            ?>
            </ul>
            <?php
        }
    }
}

