/**
 * Admin Script
 **/
(function($){

    //Ticket handler
    $.fn.iptrac_ticket = function() {
        
        var cont = $(this);
        
        //Close modal
        $( '.iptrac-modal-close-link' ).click( function(){
            var parent = $(this).parents( '.iptrac-modal' );
            $( '.ipadm-alert', parent ).remove();
            parent.hide();
            return false;
        });
        
        //Cancel modal
        $( '.iptrac-modal-cancel' ).click( function(){
            var parent = $(this).parents( '.iptrac-modal' );
            $( '.ipadm-alert', parent ).remove();
            parent.hide();
            return false;
        });
        
        //Setup
        $( '.iptrac-file-edit', cont ).click( function(){
            openFileEdit( $(this) );
            return false;
        });
        $( '.iptrac-file-delete', cont ).click( function(){
            deleteFile( $(this) );
            return false;
        });
        
        //Show upload handler
        $( '#iptrac-show-upload-modal' ).click( function(){
        
            resetAttachForm();
            $( '#iptrac-attach-add-title' ).show();
            $( '#iptrac-attach-edit-title' ).hide();
            $( '#iptrac-do-add-attach' ).show();
            $( '#iptrac-do-edit-attach' ).hide();
            $( '#iptrac-add-modal' ).show();
            $( '#input-attach-file' ).show();
            $( '.iptrac-file-info' ).hide();
            return false;
        });
        
        //Do add file
        var formdata = false,
            files = 'null';
            
        if (window.FormData) {
            formdata = new FormData();
        }
        $( '#input-attach-file' ).change( function(){
            files = this.files;
        });
        
        $( '#iptrac-do-add-attach' ).click( function(){
        
            var button  = $(this);
            var modal   = button.parents( '.iptrac-modal' );
            var actions = button.parents( '.iptrac-form-actions' );
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            if ( files == 'null' ) {
                iptrac_tools.showInputMessage( iptrac_msg.attach_file, 'danger', $( '#input-attach-file' ) );
                return false;
            }
            
            var len = files.length;
            for ( var i = 0; i < len; i++ ) 
            {
                file = files[i];
                if ( window.FileReader ) {
                    reader = new FileReader();
                    reader.readAsDataURL(file);
                }
                if (formdata) {
                    formdata.append("async-upload", file);
                }
            }
            var tickId = $( '#value-ticket-id' ).val();
            if (formdata) {
            
                var title = $( '#input-file-title' ).val();
                var desc = $( '#input-file-desc' ).val();
                formdata.append( 'file_title', title );
                formdata.append( 'file_desc', desc );
                formdata.append( 'ticket_id', tickId );
            
                $.ajax({
                    url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_add_file',
                    type: "POST",
                    data: formdata,
                    processData: false,
                    contentType: false,
                    dataType: "json",
                    success: function ( result ) {
                    
                        if ( result.status == '1' ) {
                            
                            $( '#value-ticket-id' ).val( result.id );
                            
                            //Create file list
                            $( '#iptrac-file-list-values' ).show();
                            $( '#iptrac-file-list-values ul' ).show();
                            $( '#iptrac-file-list-empty' ).hide();
                                
                            var file = $( '<li id="iptrac-file-'+result.id+'" class="iptrac-file-item"></li>' );
                            $( '<div class="iptrac-file-label"></div>' )
                                 .append( '<i class="fa fa-file"></i>' )
                                 .append( '<strong>' + result.name + '</strong>' )
                                 .appendTo( file );
                            
                            var editAct = $( '<a class="iptrac-file-edit" href="#"><i class="fa fa-pencil"></i> Edit</a>' )
                                            .click( function(){
                                                openFileEdit( $(this) );
                                                return false;
                                            });
                            var delAct  = $( '<a class="iptrac-file-delete" href="#"><i class="fa fa-trash-o"></i> Delete</a>' )
                                            .click( function(){
                                                deleteFile( $(this) );
                                                return false;
                                            });
                            
                            $( '<div class="iptrac-file-actions"></div>' )
                                .append( '<a target="__blank" class="iptrac-file-download" href="'+result.url+'"><i class="fa fa-download"></i> Download</a>' )
                                .append( editAct )
                                .append( delAct )
                                .appendTo( file );
                            
                            $( '#iptrac-file-list-values ul' ).append( file );
                            
                        }
                        //Show message
                        if ( result.status == 1 ) 
                        {
                            var type = 'iptrac-success';
                        } else {
                            var type = 'iptrac-error';
                        }
                        iptrac_tools.showModalMessage( result.message, type );
                        
                        //Reset file form
                        resetAttachForm();
                        
                        $( '.ipadm-btn', actions ).removeAttr( 'disabled' );
                        $( '.iptrac-modal-close-link', modal ).show();
                        loader.remove();
                        modal.hide();
                    },
                    error: function () {
                        alert( "Error in adding file" );
                    },
                    
                });
                $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
                $( '.iptrac-modal-close-link', modal ).hide();
                actions.append( loader );
            }
            return false;
        });
        
        //Do Edit Attachment
        $( '#iptrac-do-edit-attach' ).click( function(){
        
            var button  = $(this);
            var modal   = button.parents( '.iptrac-modal' );
            var actions = button.parents( '.iptrac-form-actions' );
            var fileId  = $( '#value-attach-id' ).val();
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            $( '.iptrac-modal-close-link', modal ).hide();
            actions.append( loader );
            
            var title    = $( '#input-file-title' ).val();
            var desc     = $( '#input-file-desc' ).val();
            var tickId   = $( '#value-ticket-id' ).val();
            var formdata = 'file_title=' + title + '&file_desc=' + desc + '&file_id=' + fileId + '&ticket_id=' + tickId;
                
                $.ajax({
                    url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_edit_file',
                    type: "POST",
                    data: formdata,
                    dataType: "json",
                    success: function ( result ) {
                        
                        $( '.ipadm-btn', actions ).removeAttr( 'disabled' );
                        $( '.iptrac-modal-close-link', modal ).show();
                        loader.remove();
                        
                        if ( result.status == 1 ) 
                        {
                            var label = result.name;
                            $( '#iptrac-file-'+fileId+' .iptrac-file-label strong' ).text( label );
                            var type = 'iptrac-success';
                        } else {
                            var type = 'iptrac-error';
                        }
                        iptrac_tools.showModalMessage( result.message, type );
                    },
                });
                
            return false;
        });
        
        function resetAttachForm()
        {
            document.getElementById("iptrac-form-add-attach").reset();
            $( '.iptrac-file-info' ).remove();
        }
        
        function openFileEdit( button )
        {
            var object = button.parents( '.iptrac-file-item' );
            $( '#iptrac-modal-loader-overlay' ).show();
            resetAttachForm();
            
            var id = object.attr( 'id' ).replace( 'iptrac-file-', '' );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_get_file'+'&id='+id,
                type: "POST",
                dataType: "json",
                success: function ( result ) {
                    
                    if ( result.status == '1' ) {
                    
                        $( '#value-attach-id' ).val( result.id );
                        $( '#input-file-title' ).val( result.title );
                        $( '#input-file-desc' ).val( result.desc );
                        $( '#input-attach-file' ).hide();
                        //Add file info
                        $( '.iptrac-file-input' ).prepend(
                            '<div class="iptrac-file-info"><strong>' + result.file + '</strong></div>'
                        );
                    }
                    $( '#iptrac-attach-add-title' ).hide();
                    $( '#iptrac-attach-edit-title' ).show();
                    $( '#iptrac-do-add-attach' ).hide();
                    $( '#iptrac-do-edit-attach' ).show();
                    $( '#iptrac-add-modal' ).show();
                    
                    $( '#iptrac-modal-loader-overlay' ).hide();
                }
            });
        }
        
        function deleteFile( button )
        {
            var object = button.parents( '.iptrac-file-item' );
            $( '#iptrac-modal-loader-overlay' ).show();
            
            var id   = object.attr( 'id' ).replace( 'iptrac-file-', '' );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_delete_file'+'&id='+id,
                type: "POST",
                dataType: "json",
                success: function ( result ) {
                
                    if ( result.status == 1 ) {
                        object.animate({opacity: "0", height: "0"}, 600, function(){
                            setTimeout( function(){
                                object.remove();
                                if ( $( '#iptrac-file-list-values li' ).length < 1 ) 
                                {
                                    $( '#iptrac-file-list-values' ).hide();
                                    $( '#iptrac-file-list-empty' ).show();
                                }
                            }, 4000);
                        });
                    }
                    
                    $( '#iptrac-modal-loader-overlay' ).hide();
                    if ( result.status == 1 ) {
                        var type = 'iptrac-success';
                    } else {
                        var type = 'iptrac-error';
                    }
                    iptrac_tools.showModalMessage( result.message, type );
                }
            });
        }
        
        // Get product version
        $( '#input-product', cont ).change( function(){
            
            var value = $( this ).val();
            
            //Reset options
            var label = $( '#input-version option:first-child', cont );
            if ( label.val() == 0 ) {
                $( '#input-version', cont ).html( label );
            }
            else {
                $( '#input-version', cont ).html( '' );
            }
            
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_get_product_version&product='+value,
                type: "POST",
                success: function (result) {
                    $( '#input-version', cont ).append( result );
                },
                error: function () {
                    alert( "Error in Deleting focus" );
                },
            });
        });
        
        //Show edit ticket form
        $( '#iptrac-ticket-btn-edit' ).click( function(){
            $( '#iptrac-ticket-modal' ).show();
            return false;
        });
        
        // Edit ticket
        $( '#iptrac-edit-ticket' ).click( function(){
        
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var form    = button.parents( 'form' );
            var tickId  = $( '#value-ticket-id' ).val();
            var utype   = $( '.value-user-type', form ).val();
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = iptrac_tools.getdataform( form );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_edit_ticket&utype='+utype,
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    window.location.href = result.redirect;
                },
            });
            return false;
        });
        
        //Show send message form
        $( '#iptrac-show-message-modal' ).click( function(){
            $( '#iptrac-msg-modal' ).show();
            return false;
        });
        
        //Send message
        $( '#iptrac-send-message' ).click( function(){
        
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var form    = button.parents( 'form' );
            var tickId  = $( '#value-ticket-id' ).val();
            var utype   = $( '.value-user-type', form ).val();
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = iptrac_tools.getdataform( form );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_send_message&utype='+utype,
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    window.location.href = result.redirect;
                },
            });
            return false;
        });
        
        // Close ticket
        $( '#iptrac-do-ticket-close' ).click( function(){
        
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var tickId  = button.attr( 'href' ).replace( '#ticket_', '' );
            var utype   = button.data( 'user-type' );
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = 'ticket_id=' + tickId + '&utype=' + utype;
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_close_ticket',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    window.location.href = result.redirect;
                },
            });
            return false;
        });
        
        // Reopen ticket
        $( '#iptrac-do-ticket-reopen' ).click( function(){
        
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var tickId  = button.attr( 'href' ).replace( '#ticket_', '' );
            var utype   = button.data( 'user-type' );
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = 'ticket_id=' + tickId + '&utype=' + utype;
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_reopen_ticket',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    window.location.href = result.redirect;
                },
            });
            return false;
        });
        
        //Accept ticket
        $( '#iptrac-do-ticket-accept' ).click( function(){
        
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var tickId  = button.attr( 'href' ).replace( '#ticket_', '' );
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = 'ticket_id=' + tickId;
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_accept_ticket',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    window.location.href = result.redirect;
                },
            });
            return false;
        });
        
        //Reject ticket
        $( '#iptrac-do-ticket-reject' ).click( function(){
        
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var tickId  = button.attr( 'href' ).replace( '#ticket_', '' );
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = 'ticket_id=' + tickId;
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_reject_ticket',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    window.location.href = result.redirect;
                },
            });
            return false;
        });
        
        //Delete ticket
        $( '.ip_tickDelete' ).each( function(){
            
            var button = $(this);
            button.click( function(){
            
                var id = button.attr( 'href' ).replace( '#toDeleteTicket_', '' );
                $( '.ipadm_loader_small' ).remove();
                var loader = '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>';
                button.after( loader );
                
                button.addClass( 'ipadm-btn-disabled' )
                      .attr( 'disabled', 'disabled' );
                
                $.ajax({
                    url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_delete_ticket&id='+id,
                    type: "POST",
                    dataType: "json",
                    success: function (result) {
                        
                        if ( result.status == '-1' ) {
                            iptrac_tools.showMessage( result.message, 'ipadm-error' );
                        } else {
                            iptrac_tools.showMessage( result.message, 'ipadm-success' );
                            var tr = button.parents( 'tr' );
                            tr.hide( 'blind' );
                            setTimeout( function(){
                                tr.remove();
                            }, 600);
                        }
                        button.removeClass( 'ipadm-btn-disabled' )
                              .removeAttr( 'disabled' );
                        $( '.ipadm-loader-small' ).remove();
                        
                    },
                    error: function () {
                        alert( "Error in Deleting ticket" );
                    },
                });
                
                return false;
            });
        });
    };
    
    
    //Product handler
    $.fn.iptrac_product = function() {
    
        var cont = $(this);
        
        //Add action
        $( '#iptrac-add-product' ).click( function(){
            
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var form    = button.parents( 'form' );
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            var title = $( '#input-title' ).val();
            if ( title == '' ) {
                iptrac_tools.showInputMessage( iptrac_msg.product_title, 'danger', $( '#input-title' ) );
                return false;
            }
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = iptrac_tools.getdataform( form );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_add_product',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    
                    window.location.href = 'admin.php?page=iptrac-admin-product&add=1';
                    $( '.ipadm-btn', actions ).removeAttr( 'disabled' );
                    loader.remove();
                },
            });
            return false;
        });
        
        //Edit action
        $( '#iptrac-edit-product' ).click( function(){
            
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var form    = button.parents( 'form' );
            var prodId  = $( '#value-product-id' ).val();
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            var label = $( '#input-type-label' ).val();
            if ( label == '' ) {
                iptrac_tools.showInputMessage( iptrac_msg.type_label, 'danger', $( '#input-type-label' ) );
                return false;
            }
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = iptrac_tools.getdataform( form );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_edit_product',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    
                    if ( result.status = 1 ) {
                        window.location.href = 'admin.php?page=iptrac-admin-product&action=edit&id='+prodId+'&result=1';
                    } else {
                        window.location.href = 'admin.php?page=iptrac-admin-product&action=edit&id='+prodId+'&result=0';
                    }
                    $( '.ipadm-btn', actions ).removeAttr( 'disabled' );
                    loader.remove();
                },
            });
            return false;
        });
        
        //Delete product
        $( '.ip_prodDelete' ).each( function(){
            
            var button = $(this);
            button.click( function(){
            
                var id = button.attr( 'href' ).replace( '#toDeleteProduct_', '' );
                $( '.ipadm_loader_small' ).remove();
                var loader = '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>';
                button.after( loader );
                
                button.addClass( 'ipadm-btn-disabled' )
                      .attr( 'disabled', 'disabled' );
                
                $.ajax({
                    url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_delete_product&id='+id,
                    type: "POST",
                    dataType: "json",
                    success: function (result) {
                        
                        if ( result.status == '-1' ) {
                            iptrac_tools.showMessage( result.message, 'ipadm-error' );
                        } else {
                            iptrac_tools.showMessage( result.message, 'ipadm-success' );
                            var tr = button.parents( 'tr' );
                            tr.hide( 'blind' );
                            setTimeout( function(){
                                tr.remove();
                            }, 600);
                        }
                        button.removeClass( 'ipadm-btn-disabled' )
                              .removeAttr( 'disabled' );
                        $( '.ipadm-loader-small' ).remove();
                        
                    },
                    error: function () {
                        alert( "Error in Deleting product" );
                    },
                });
                
                return false;
            });
        });
    };
    
    //Version handler
    $.fn.iptrac_version = function() {
        
        var cont = $(this);
        
        //Close modal
        $( '.iptrac-modal-close-link' ).click( function(){
            var parent = $(this).parents( '.iptrac-modal' );
            $( '#input-version-label' ).val('');
            $( '.ipadm-alert', parent ).remove();
            parent.hide();
            return false;
        });
        
        //Cancel modal
        $( '.iptrac-modal-cancel' ).click( function(){
            var parent = $(this).parents( '.iptrac-modal' );
            $( '#input-version-label' ).val('');
            $( '.ipadm-alert', parent ).remove();
            parent.hide();
            return false;
        });
            
        //Show add version
        $( '#iptrac-show-add-version' ).click( function(){
            
            $( '#input-version-label' ).val('');
            $( '#iptrac-vers-add-title' ).show();
            $( '#iptrac-vers-edit-title' ).hide();
            $( '#iptrac-do-add-version' ).show();
            $( '#iptrac-do-edit-version' ).hide();
            $( '#iptrac-add-modal' ).show();
            return false;
        });
        
        //Edit
        $( '#iptrac-vers-list-values .iptrac-vers-edit' ).click( function(){
            openVersionEdit( $(this) );
            return false;
        });
        //Delete
        $( '#iptrac-vers-list-values .iptrac-vers-delete' ).click( function(){
            deleteVersion( $(this) );
            return false;
        });
        
        //Do add version
        $( '#iptrac-do-add-version' ).click( function(){
        
            var button  = $(this);
            var modal   = button.parents( '.iptrac-modal' );
            var actions = button.parents( '.iptrac-form-actions' );
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            var label = $( '#input-version-label' ).val();
            if ( label == '' ) {
                iptrac_tools.showInputMessage( iptrac_msg.version_label, 'danger', $( '#input-version-label' ) );
                return false;
            }
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            $( '.iptrac-modal-close-link', modal ).hide();
            actions.append( loader );
            
            var formdata = iptrac_tools.getdataform( modal );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_add_version',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    
                    if ( result.status == '1' ) {
                        
                        $( '#value-version-id' ).val( result.id );
                        
                        //Create version list
                        $( '#iptrac-vers-list-values' ).show();
                        $( '#iptrac-vers-list-values ul' ).show();
                        $( '#iptrac-vers-list-empty' ).hide();
                            
                        var version = $( '<li id="iptrac-version-'+result.id+'" class="iptrac-version-item"></li>' );
                        $( '<div class="iptrac-version-label"></div>' )
                             .append( '<i class="fa fa-check"></i>' )
                             .append( '<strong>' + result.label + '</strong>' )
                             .appendTo( version );
                        
                        var editAct = $( '<a class="iptrac-vers-edit" href="#"><i class="fa fa-pencil"></i> Edit</a>' )
                                        .click( function(){
                                            openVersionEdit( $(this) );
                                            return false;
                                        });
                        var delAct  = $( '<a class="iptrac-vers-delete" href="#"><i class="fa fa-trash-o"></i> Delete</a>' )
                                        .click( function(){
                                            deleteVersion( $(this) );
                                            return false;
                                        });
                        
                        $( '<div class="iptrac-version-actions"></div>' )
                            .append( editAct )
                            .append( delAct )
                            .appendTo( version );
                        
                        $( '#iptrac-vers-list-values ul' ).append( version );
                        
                    }
                    //Reset version form
                    $( '#input-version-label' ).val('');
                    
                    $( '.ipadm-btn', actions ).removeAttr( 'disabled' );
                    $( '.iptrac-modal-close-link', modal ).show();
                    loader.remove();
                    modal.hide();
                },
            });
            
            return false;
        });
        
        //Do Edit Version
        $( '#iptrac-do-edit-version' ).click( function(){
        
            var button  = $(this);
            var modal   = button.parents( '.iptrac-modal' );
            var actions = button.parents( '.iptrac-form-actions' );
            var versId  = $( '#value-version-id' ).val();
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            $( '.iptrac-modal-close-link', modal ).hide();
            actions.append( loader );
            
            var formdata = iptrac_tools.getdataform( modal );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_edit_version',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    
                    $( '.ipadm-btn', actions ).removeAttr( 'disabled' );
                    $( '.iptrac-modal-close-link', modal ).show();
                    loader.remove();
                    
                    if ( result.status == 1 ) {
                        
                        var label = $( '#input-version-label' ).val();
                        $( '#iptrac-version-'+versId+' .iptrac-version-label strong' ).text( label );
                        var type = 'iptrac-success';
                    } else {
                        var type = 'iptrac-error';
                    }
                    iptrac_tools.showModalMessage( result.message, type );
                },
            });
            return false;
        });
        
        
        function openVersionEdit( button )
        {
            var object = button.parents( '.iptrac-version-item' );
            $( '#iptrac-modal-loader-overlay' ).show();
            $( '#input-version-label' ).val('');
            
            var id = object.attr( 'id' ).replace( 'iptrac-version-', '' );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_get_version'+'&id='+id,
                type: "POST",
                dataType: "json",
                success: function ( result ) {
                    
                    if ( result.status == '1' ) {
                    
                        $( '#input-version-label' ).val( result.label );
                        $( '#value-version-id' ).val( result.id );
                    }
                    $( '#iptrac-vers-add-title' ).hide();
                    $( '#iptrac-vers-edit-title' ).show();
                    $( '#iptrac-do-add-version' ).hide();
                    $( '#iptrac-do-edit-version' ).show();
                    $( '#iptrac-add-modal' ).show();
                    
                    $( '#iptrac-modal-loader-overlay' ).hide();
                }
            });
        }
        
        function deleteVersion( button )
        {
            var object = button.parents( '.iptrac-version-item' );
            $( '#iptrac-modal-loader-overlay' ).show();
            
            var id   = object.attr( 'id' ).replace( 'iptrac-version-', '' );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_delete_version'+'&id='+id,
                type: "POST",
                dataType: "json",
                success: function ( result ) {
                
                    if ( result.status == 1 ) {
                        object.animate({opacity: "0", height: "0"}, 600, function(){
                            setTimeout( function(){
                                object.remove();
                                if ( $( '#iptrac-vers-list-values li' ).length < 1 ) 
                                {
                                    $( '#iptrac-vers-list-values' ).hide();
                                    $( '#iptrac-vers-list-empty' ).show();
                                }
                            }, 4000);
                        });
                    }
                    
                    $( '#iptrac-modal-loader-overlay' ).hide();
                    if ( result.status == 1 ) {
                        var type = 'iptrac-success';
                    } else {
                        var type = 'iptrac-error';
                    }
                    iptrac_tools.showModalMessage( result.message, type );
                }
            });
        }
    };
    
    //Type page handler
    $.fn.iptrac_type = function() {
    
        var root = $(this);
        
        //Add action
        $( '#iptrac-add-type' ).click( function(){
            
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var form    = button.parents( 'form' );
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            var label = $( '#input-type-label' ).val();
            if ( label == '' ) {
                iptrac_tools.showInputMessage( iptrac_msg.type_label, 'danger', $( '#input-type-label' ) );
                return false;
            }
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = iptrac_tools.getdataform( form );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_add_type',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    
                    window.location.href = 'admin.php?page=iptrac-admin-type&add=1';
                    $( '.ipadm-btn', actions ).removeAttr( 'disabled' );
                    loader.remove();
                },
            });
            return false;
        });
        
        //Edit action
        $( '#iptrac-edit-type' ).click( function(){
            
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var form    = button.parents( 'form' );
            var typeId  = $( '#value-type-id' ).val();
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            var label = $( '#input-type-label' ).val();
            if ( label == '' ) {
                iptrac_tools.showInputMessage( iptrac_msg.type_label, 'danger', $( '#input-type-label' ) );
                return false;
            }
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = iptrac_tools.getdataform( form );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_edit_type',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    
                    if ( result.status = 1 ) {
                        window.location.href = 'admin.php?page=iptrac-admin-type&action=edit&id='+typeId+'&result=1';
                    } else {
                        window.location.href = 'admin.php?page=iptrac-admin-type&action=edit&id='+typeId+'&result=0';
                    }
                    $( '.ipadm-btn', actions ).removeAttr( 'disabled' );
                    loader.remove();
                },
            });
            return false;
        });
    
        //Delete Type
        $( '.ip_typeDelete' ).each( function(){
            
            var button = $(this);
            button.click( function(){
            
                var id = button.attr( 'href' ).replace( '#toDeleteType_', '' );
                $( '.ipadm_loader_small' ).remove();
                var loader = '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>';
                button.after( loader );
                
                button.addClass( 'ipadm-btn-disabled' )
                      .attr( 'disabled', 'disabled' );
                
                $.ajax({
                    url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_deletetype&id='+id,
                    type: "POST",
                    dataType: "json",
                    success: function (result) {
                        
                        if ( result.status == '-1' ) {
                            iptrac_tools.showMessage( result.message, 'ipadm-error' );
                        } else {
                            iptrac_tools.showMessage( result.message, 'ipadm-success' );
                            var tr = button.parents( 'tr' );
                            tr.hide( 'blind' );
                            setTimeout( function(){
                                tr.remove();
                            }, 600);
                        }
                        button.removeClass( 'ipadm-btn-disabled' )
                              .removeAttr( 'disabled' );
                        $( '.ipadm-loader-small' ).remove();
                        
                    },
                    error: function () {
                        alert( "Error in Deleting type" );
                    },
                });
                
                return false;
            });
        });
    };
    
    //Focus page handler
    $.fn.iptrac_focus = function() {
    
        var root = $(this);
        
        //Add action
        $( '#iptrac-add-focus' ).click( function(){
            
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var form    = button.parents( 'form' );
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            var label = $( '#input-focus-label' ).val();
            if ( label == '' ) {
                iptrac_tools.showInputMessage( iptrac_msg.focus_label, 'danger', $( '#input-focus-label' ) );
                return false;
            }
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = iptrac_tools.getdataform( form );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_add_focus',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    
                    window.location.href = 'admin.php?page=iptrac-admin-focus&add=1';
                    $( '.ipadm-btn', actions ).removeAttr( 'disabled' );
                    loader.remove();
                },
            });
            return false;
        });
        
        //Edit action
        $( '#iptrac-edit-focus' ).click( function(){
            
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var form    = button.parents( 'form' );
            var focusId = $( '#value-focus-id' ).val();
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            var label = $( '#input-focus-label' ).val();
            if ( label == '' ) {
                iptrac_tools.showInputMessage( iptrac_msg.focus_label, 'danger', $( '#input-focus-label' ) );
                return false;
            }
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = iptrac_tools.getdataform( form );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_edit_focus',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    
                    if ( result.status = 1 ) {
                        window.location.href = 'admin.php?page=iptrac-admin-focus&action=edit&id='+focusId+'&result=1';
                    } else {
                        window.location.href = 'admin.php?page=iptrac-admin-focus&action=edit&id='+focusId+'&result=0';
                    }
                    $( '.ipadm-btn', actions ).removeAttr( 'disabled' );
                    loader.remove();
                },
            });
            return false;
        });
        
        //Delete Focus
        $( '.ip_focusDelete' ).each( function(){
            
            var button = $(this);
            button.click( function(){
            
                var id = button.attr( 'href' ).replace( '#toDeleteFocus_', '' );
                $( '.ipadm_loader_small' ).remove();
                var loader = '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>';
                button.after( loader );
                
                button.addClass( 'ipadm-btn-disabled' )
                      .attr( 'disabled', 'disabled' );
                
                $.ajax({
                    url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_deletefocus&id='+id,
                    type: "POST",
                    dataType: "json",
                    success: function (result) {
                        
                        if ( result.status == '-1' ) {
                            iptrac_tools.showMessage( result.message, 'ipadm-error' );
                        } else {
                            iptrac_tools.showMessage( result.message, 'ipadm-success' );
                            var tr = button.parents( 'tr' );
                            tr.hide( 'blind' );
                            setTimeout( function(){
                                tr.remove();
                            }, 600);
                        }
                        button.removeClass( 'ipadm-btn-disabled' )
                              .removeAttr( 'disabled' );
                        $( '.ipadm-loader-small' ).remove();
                        
                    },
                    error: function () {
                        alert( "Error in Deleting focus" );
                    },
                });
                
                return false;
            });
        });
    };
    
    //Setting handler
    $.fn.iptrac_setting = function() {
    
        var root = $(this);
        
        //Input global
        changeInputGlobal( $( '#input-global-notif' ) );
        $( '#input-global-notif' ).change( function(){
            changeInputGlobal( $(this) );
        });
        
        function changeInputGlobal( input )
        {
            if ( input.is(':checked') ) 
            {
                $( '#iptrac-global-email' ).show();
                input.attr( 'checked', 'checked' );
            }
            else 
            {
                $( '#iptrac-global-email' ).hide();
                input.removeAttr( 'checked' );
            }
        }
        
        //Save action
        $( '#iptrac-do-save-setting' ).click( function(){
            
            var button  = $(this);
            var actions = button.parents( '.ipadm-btn-wrap' );
            var form    = button.parents( 'form' );
            var loader  = $( '<div style="margin-left: 6px;" class="ipadm-loader-small"></div>' );
            
            $( '.ipadm-btn', actions ).attr( 'disabled', 'disabled' );
            actions.append( loader );
            
            var formdata = iptrac_tools.getdataform( form );
            $.ajax({
                url: ajaxurl+'?doajax=1&iptrac=1&action=iptrac_save_setting',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    
                    if ( result.status = 1 ) {
                        window.location.href = 'admin.php?page=iptrac-admin-setting&result=1';
                    } else {
                        window.location.href = 'admin.php?page=iptrac-admin-setting&result=0';
                    }
                    $( '.ipadm-btn', actions ).removeAttr( 'disabled' );
                    loader.remove();
                },
            });
            return false;
        });
    };
    
    //Filter handler
    $.fn.iptrac_ticket_filter = function() {
    
        $( '.iptrac-input-all' ).click( function(){
            var root = $(this).parents( '.filter-options' );
            if ( $(this).is(':checked')) {
                $( 'input[type="checkbox"]', root ).attr( 'checked', 'checked' );
            }
        });
        $( '.filter-options input[type="checkbox"]' ).click( function(){
            var root = $(this).parents( '.filter-options' );
            if ( ! $(this).hasClass( '.iptrac-input-all' ) ) {
                if ( ! $(this).is(':checked')) {
                    $( '.iptrac-input-all', root ).removeAttr( 'checked', 'checked' );
                }
            }
        });
    };
    
    //Tools
    var iptrac_tools = {
    
        goTo: function( id ){
            var pos = $( id ).position();
            $('html, body').animate({scrollTop: ( pos.top )}, 600);
            return false;
        },
        showMessage: function( msg, eclass ) {
            
            $( '#ipadm-messages' ).html( msg )
                                  .attr( 'class', eclass )
                                  .show();
                                  
            setTimeout( function(){
                $( '#ipadm-messages' ).animate({opacity: "0"}, 600, function(){
                    $(this).html( '' ).hide();
                    $( '#ipadm-messages' ).css( 'opacity', 1 );
                });
            }, 4000 );
        },
        showInputMessage: function( msg, type, input, timeout ) {
    
            $( '.ipadm-alert' ).remove();
            var msgHtml = $( '<div class="ipadm-alert"></div>' );
            msgHtml.addClass( 'ipadm-alert-' + type );
            msgHtml.html( msg );
            
            $( input ).before( msgHtml );
            if ( timeout ) {
                setTimeout( function(){
                    msgHtml.animate({opacity: "0"}, 600, function(){
                        msgHtml.remove();
                    });
                }, 4000 );
            }
        },
        getdataform: function( parent ) 
        {
            var selector  = 'input[type=text]';
            selector += ', input[type=hidden]';
            selector += ', input[type=password]';
            selector += ', input[type=radio]:checked';
            selector += ', input[type=checkbox]:checked';
            selector += ', textarea';
            selector += ', select';
            
            var data = '';
            
            $( selector, parent ).each( function(){
                var name  = $(this).attr( 'name' );
                var value = encodeURIComponent( $(this).val() );
                
                if ( data != '' ) {
                    data += '&';
                }
                data += name+'='+value;
            });
            if (typeof tinymce !== 'undefined') {
                for ( edId in tinymce.editors ) {
                    
                    if ( edId.length > 1 ) {
                        var value = tinymce.editors[edId].getContent();
                        if ( data != '' ) {
                            data += '&';
                        }
                        data += edId+'='+value;
                    }
                }
            }
            return data;
        },
        showModalMessage: function( message, type )
        {
            $( '#iptrac-modal-message' ).text( message );
            $( '#iptrac-modal-message-overlay' )
                .removeAttr( 'class' )
                .attr( 'class', type )
                .show()
                .animate({top: "0"}, 600, function(){
                    var msg = $(this);
                    setTimeout( function(){
                        msg.animate({top: '-100px'}, 600, function(){
                            msg.hide();
                        });
                    }, 4000);
                });
        }
    };
    
    $(document).ready(function() {
    
        // Run ticket handler
        $( '#iptrac-manage-ticket' ).iptrac_ticket();
        
        // Run product handler
        $( '#iptrac-manage-product' ).iptrac_product();
        
        // Run version handler
        $( '#iptrac-manage-product' ).iptrac_version();
        
        // Run type handler
        $( '#iptrac-manage-type' ).iptrac_type();
        
        // Run focus handler
        $( '#iptrac-manage-focus' ).iptrac_focus();
        
        // Run setting handler
        $( '#iptrac-admin-setting' ).iptrac_setting();
        
        // Run setting handler
        $( '#iptrac-manage-ticket .iptrac-filter' ).iptrac_ticket_filter();
        
    });
})(jQuery);