<?php
if ( ! class_exists( 'IPTrac_AdminTicket' )) {

    /**
     * Class for handling administrator page
     */
    class IPTrac_AdminTicket
    {
        /**
         * Show content admin send ticket
         *
         * @return void
         */
        public function userSend()
        {
            $action = 'form';
            if ( ! empty( $_GET['action'] )) {
                $action = trim( $_GET['action'] );
            }
            if ( $action == 'addfile' ) {
                $this->userSendFile();
            }
            else {
                $this->userSendForm();
            }
        }
        
        /**
         * Show content admin send ticket
         *
         * @return void
         */
        public function userSendFile()
        {
            global $user_ID;
            
            $model  = new IPTrac_Model();
            $ticket = false;
            if ( ! empty( $_GET['ticket'] )) {
                $id     = absint( $_GET['ticket'] );
                $ticket = $model->getTicket( $id, $user_ID );
            }
            if ( ! $ticket ) {
                wp_die( __('You do not have sufficient permissions to access this page.', 'wpiptrac') );
            }
        ?>
            <div id="iptrac-manage-ticket" class="wrap ipadm-wrap iptrac-admin">
                <div class="ipadm-inner">
                    <div class="ipadm-header">
                        <div class="ipadm-page-title">
                            <h1>
                                <i class="fa fa-ticket"></i>
                                <span class="ipadm-title"><?php _e( 'Add File', 'wpiptrac' ); ?></span>
                            </h1>
                        </div>
                    </div>
                    
                    <div class="ipadm-body">
                        
                        <div class="ipadm-main">
                        
                            <p class="ipadm-alert ipadm-alert-success"><?php _e( 'Successfully added new ticket', 'wpiptrac' ); ?></p>
                            
                            <p><?php _e( 'Now you can include multiple files into a ticket via the form below.', 'wpiptrac' ); ?></p>
                            
                            <div class="iptrac-file-list">
                                <h3><?php _e( 'Files List', 'wpiptrac' ); ?></h3>
                                <?php 
                                if ( $files = $model->getAttachments( $ticket->tick_id ) ) :
                                ?>
                                <div id="iptrac-file-list-values">
                                    <ul>
                                    <?php
                                    foreach( $files as $file ) :
                                    
                                        $name = '';
                                        if ( ! empty( $file->post_title )) {
                                            $name = $file->post_title;
                                        } elseif ( ! empty( $file->post_name )) {
                                            $name = $file->post_name;
                                        }
                                    ?>
                                    <li id="iptrac-file-<?php echo $file->att_id; ?>" class="iptrac-file-item">
                                        <div class="iptrac-file-label">
                                            <i class="fa fa-file"></i>
                                            <strong><?php echo $name; ?></strong>
                                        </div>
                                        <div class="iptrac-file-actions">
                                            <a target="__blank" class="iptrac-file-download" href="<?php echo $file->guid; ?>"><i class="fa fa-download"></i> Download</a>
                                            <a class="iptrac-file-edit" href="#"><i class="fa fa-pencil"></i> Edit</a>
                                            <a class="iptrac-file-delete" href="#"><i class="fa fa-trash-o"></i> Delete</a>
                                        </div>
                                    </li>
                                    <?php
                                    endforeach;
                                    ?>
                                    </ul>
                                </div>
                                <div id="iptrac-file-list-empty" style="display:none;">
                                    <p class="ipadm-empty"><em><?php _e( 'File not found', 'wpiptrac' ); ?></em></p>
                                </div>
                                <?php
                                else :
                                ?>
                                <div id="iptrac-file-list-values" style="display:none;">
                                    <ul></ul>
                                </div>
                                <div id="iptrac-file-list-empty">
                                    <p class="ipadm-empty"><em><?php _e( 'File not found', 'wpiptrac' ); ?></em></p>
                                </div>
                                <?php
                                endif;
                                ?>
                                <div class="iptrac-add-file">
                                    <a id="iptrac-show-upload-modal" href="#" class="button"><i class="fa fa-cloud-upload"></i> Add File</a>
                                </div>
                            </div>
                            
                            <div id="iptrac-addfile-finish" class="ipadm-btn-wrap">
                                <a href="admin.php?page=iptrac-user-manage&action=edit&id=<?php echo $ticket->tick_id; ?>" class="ipadm-btn ipadm-btn-primary">Finish</a>
                            </div>
                            
                        </div>
                    </div>
                </div>

<div id="iptrac-add-modal" class="iptrac-modal" style="display: none;">
    <div class="iptrac-modal-inner">
        <div id="iptrac-add-att-content" class="iptrac-modal-main">
        
            <div class="iptrac-modal-close">
                <a class="iptrac-modal-close-link" href="#">x</a>
            </div>
            
            <h3 id="iptrac-attach-add-title" class="iptrac-modal-title"><?php _e( 'Add Attachment', 'wpiptrac' ); ?></h3>
            <h3 id="iptrac-attach-edit-title" class="iptrac-modal-title" style="display:none;">
                <?php _e( 'Edit Attachment', 'wpiptrac' ); ?>
            </h3>
            
            <div class="iptrac-modal-content">
                
                <div class="ipadm-main">
                    <div class="ipadm-form-wrap">
                        <form id="iptrac-form-add-attach" action="" method="post" enctype="multipart/form-data">
        
                            <input type="hidden" id="value-ticket-id" name="ticket_id" value="<?php echo $ticket->tick_id; ?>" />
                            <input type="hidden" id="value-attach-id" name="attach_id" value="0" />
                            
                            <div class="fields">
                                <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                                    <div class="ipadm-label">
                                        <label for="input-attach-file"><?php _e( 'File', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
                                    </div>
                                    <div class="ipadm-field">
                                        <div class="iptrac-file-input">
                                            <input type="file" name="attach_file" id="input-attach-file" />
                                        </div>
                                    </div>
                                </div>
                                <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                                    <div class="ipadm-label">
                                        <label for="input-file-title"><?php _e( 'Title', 'wpiptrac' ); ?></label>
                                    </div>
                                    <div class="ipadm-field">
                                        <input type="text" class="ipadm-input ipadm-input-widest" name="file_title" id="input-file-title" value="" />
                                    </div>
                                </div>
                                <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                                    <div class="ipadm-label">
                                        <label for="input-file-desc"><?php _e( 'Description', 'wpiptrac' ); ?></label>
                                    </div>
                                    <div class="ipadm-field">
                                        <textarea class="ipadm-input ipadm-input-widest" id="input-file-desc" name="file_desc" rows="8"></textarea>
                                    </div>
                                </div>
                            </div>
                            
                            <div class="ipadm-btn-wrap iptrac-form-actions">
                                <input type="submit" class="ipadm-btn ipadm-btn-primary" id="iptrac-do-add-attach" name="do_add_attach" value="Add attachment" />
                                <input type="submit" class="ipadm-btn ipadm-btn-primary" id="iptrac-do-edit-attach" name="do_edit_attach" value="Edit attachment" style="display: none;" />
                                <a href="#" class="ipadm-btn ipadm-btn-default iptrac-modal-cancel">Cancel</a>
                            </div>
            
                        </form>
                    </div>
                </div>
                
            </div>
            
        </div>
    </div>
</div>
<div id="iptrac-modal-loader-overlay" style="display:none;">
    <div id="iptrac-modal-loader"></div>
</div>

<div id="iptrac-modal-message-overlay" style="display:none;">
    <div id="iptrac-modal-message"></div>
</div>

            </div>
            
        <?php
        }
        
        /**
         * Show content admin send ticket
         *
         * @return void
         */
        public function userSendForm()
        {
            global $iptrac_sender;
            $model = new IPTrac_Model();
            if ( empty( $iptrac_sender )) {
                $iptrac_sender = new IPTrac_Sender();
            }
            $handler = $iptrac_sender;
        ?>
            <div id="iptrac-manage-ticket" class="wrap ipadm-wrap iptrac-admin">
                <div class="ipadm-inner">
                    <div class="ipadm-header">
                        <div class="ipadm-page-title">
                            <h1>
                                <i class="fa fa-ticket"></i>
                                <span class="ipadm-title"><?php _e( 'Send Ticket', 'wpiptrac' ); ?></span>
                            </h1>
                        </div>
                    </div>
                    
                    <div class="ipadm-body">
                        
                        <div class="ipadm-main">
                        
                            <div class="ipadm-form-wrap">
                                <form id="iptrac-form-send-ticket" action="" method="post">
                                    
                                    <input type="hidden" name="ticket_id" id="value-ticket-id" value="0" />
                                    
<div class="ipadm-form-main iptrac-onecolumn">
    
    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
        <div class="ipadm-label">
            <label for="input-summary"><?php _e( 'Summary', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
        </div>
        <div class="ipadm-field">
            <?php 
            if ( $error = $handler->getError( 'summary' ) ) {
                echo '<p class="ipadm-alert ipadm-alert-danger">' . $error . '</p>';
            }
            ?>
            <input type="text" class="ipadm-input ipadm-input-widest" id="input-summary" name="summary" value="<?php echo $handler->getValue( 'summary' ); ?>" />
        </div>
    </div>
    
    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
        <div class="ipadm-label">
            <label for="input-description"><?php _e( 'Description', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
        </div>
        <div class="ipadm-field">
            <?php 
            if ( $error = $handler->getError( 'description' ) ) {
                echo '<p class="ipadm-alert ipadm-alert-danger">' . $error . '</p>';
            }
            ?>
            <?php
            $content = $handler->getValue( 'description' );
            wp_editor( $content, 'description', array( 
                'editor_height' => 200,
            )); 
            ?>
        </div>
    </div>
    
    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
        <div class="ipadm-label">
            <label for="input-product"><?php _e( 'Product', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
        </div>
        <div class="ipadm-field">
            <?php 
            if ( $error = $handler->getError( 'product' ) ) {
                echo '<p class="ipadm-alert ipadm-alert-danger">' . $error . '</p>';
            }
            ?>
            <select name="product" id="input-product">
                <option value="0">-- <?php _e( 'Select Product', 'wpiptrac' ); ?> --</option>
                <?php 
                $selectProd = $handler->getValue( 'product' );
                if ( $products = $model->getProducts() ) {
                    foreach( $products as $product ) 
                    {
                        $sltd = '';
                        if ( $selectProd == $product->prod_id ) {
                            $sltd = ' selected="selected"';
                        }
                        echo '<option value="' . $product->prod_id . '"' . $sltd . '>' . $product->prod_title . '</option>';
                    }
                }
                ?>
            </select>
        </div>
    </div>
    
    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
        <div class="ipadm-label">
            <label for="input-version"><?php _e( 'Version', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
        </div>
        <div class="ipadm-field">
            <?php 
            if ( $error = $handler->getError( 'version' ) ) {
                echo '<p class="ipadm-alert ipadm-alert-danger">' . $error . '</p>';
            }
            ?>
            <select name="version" id="input-version">
                <option value="0">-- <?php _e( 'Select Version', 'wpiptrac' ); ?> --</option>
                <?php 
                if ( ! empty( $selectProd )) 
                {
                    $select = $handler->getValue( 'version' );
                    if ( $versions = $model->getVersions( $selectProd ) ) 
                    {
                        foreach( $versions as $version ) 
                        {
                            $sltd = '';
                            if ( $select == $version->vers_id ) {
                                $sltd = ' selected="selected"';
                            }
                            echo '<option value="' . $version->vers_id . '"' . $sltd . '>' . $version->vers_label . '</option>';
                        }
                    }
                }
                ?>
            </select>
        </div>
    </div>
    
    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
        <div class="ipadm-label">
            <label for="input-type"><?php _e( 'Type', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
        </div>
        <div class="ipadm-field">
            <?php 
            if ( $error = $handler->getError( 'type' ) ) {
                echo '<p class="ipadm-alert ipadm-alert-danger">' . $error . '</p>';
            }
            ?>
            <select name="type" id="input-type">
                <option value="0">-- <?php _e( 'Select Type', 'wpiptrac' ); ?> --</option>
                <?php 
                $select = $handler->getValue( 'type' );
                if ( $types = $model->getTypes() ) {
                    foreach( $types as $type ) 
                    {
                        $sltd = '';
                        if ( $select == $type->type_id ) {
                            $sltd = ' selected="selected"';
                        }
                        echo '<option value="' . $type->type_id . '"' . $sltd . '>' . $type->type_label . '</option>';
                    }
                }
                ?>
            </select>
        </div>
    </div>
    
    <div id="iptrac-field-attachment" class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
        <div class="ipadm-label">
            <label for="input-focus"><?php _e( 'Focus', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
        </div>
        <div class="ipadm-field">
            <?php 
            if ( $error = $handler->getError( 'focus' ) ) {
                echo '<p class="ipadm-alert ipadm-alert-danger">' . $error . '</p>';
            }
            ?>
            <select name="focus" id="input-focus">
                <option value="0">-- <?php _e( 'Select Focus', 'wpiptrac' ); ?> --</option>
                <?php 
                $select = $handler->getValue( 'focus' );
                if ( $focuses = $model->getFocuses() ) {
                    foreach( $focuses as $focus ) 
                    {
                        $sltd = '';
                        if ( $select == $focus->focus_id ) {
                            $sltd = ' selected="selected"';
                        }
                        echo '<option value="' . $focus->focus_id . '"' .$sltd . '>' . $focus->focus_label . '</option>';
                    }
                }
                ?>
            </select>
        </div>
    </div>
    
    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
        <div class="ipadm-label">
            <label for="input-staff"><?php _e( 'Staff', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
        </div>
        <div class="ipadm-field">
            <?php 
            if ( $error = $handler->getError( 'staff' ) ) {
                echo '<p class="ipadm-alert ipadm-alert-danger">' . $error . '</p>';
            }
            ?>
            <select name="staff" id="input-staff">
                <option value="0">-- <?php _e( 'Select Staff', 'wpiptrac' ); ?> --</option>
                <?php 
                $select    = $handler->getValue( 'staff' );
                $userQuery = new WP_User_Query( array( 'role' => 'Administrator' ) );
                if ( $users = $userQuery->get_results() ) {
                    foreach( $users as $user ) {
                        $name = '';
                        if ( ! empty( $user->user_name )) {
                            $name = $user->user_name;
                        }
                        elseif ( ! empty( $user->user_nicename )) {
                            $name = $user->user_nicename;
                        }
                        elseif ( ! empty( $user->user_login )) {
                            $name = $user->user_login;
                        }
                        $sltd = '';
                        if ( $select == $user->ID ) {
                            $sltd = ' selected="selected"';
                        }
                        echo '<option value="' . $user->ID . '"' .$sltd . '>' . $name . '</option>';
                    }
                }
                ?>
            </select>
        </div>
    </div>
    
    <div class="ipadm-btn-wrap">
        <input type="submit" id="iptrac-send-ticket" name="do_send_ticket" class="ipadm-btn ipadm-btn-primary ipadm-btn-large" value="Send ticket" />
    </div>
    
</div>

                                </form>
                            </div>
                            
                        </div>
                        
                    </div>
                    
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content manage ticket page
         *
         * @return void
         */
        public function userTicket()
        {
            $action = 'manage';
            if ( ! empty( $_GET['action'] )) {
                $action = trim( $_GET['action'] );
            }
            if ( $action == 'edit' ) {
                $this->userTicketEdit();
            }
            else {
                $this->userTicketManage();
            }
        }
        
        /**
         * Show content manage ticket page
         *
         * @return void
         */
        public function userTicketManage()
        {
        ?>
            <div id="iptrac-manage-ticket" class="wrap ipadm-wrap iptrac-admin">
                <div class="ipadm-inner">
                    
                    <div class="ipadm-header">
                        <div class="ipadm-page-title">
                            <h1>
                                <i class="fa fa-ticket"></i>
                                <span class="ipadm-title"><?php _e( 'All Tickets', 'wpiptrac' ); ?></span>
                            </h1>
                            <span class="ipadm-header-link">
                                <a href="admin.php?page=iptrac-user-send" title="<?php _e( 'Send Ticket', 'wpiptrac' ); ?>" class="ipadm-btn ipadm-btn-light ipadm-btn-mini"><?php _e( 'Send Ticket', 'wpiptrac' ); ?></a>
                            </span>
                        </div>
                    </div>
                    
                    <?php
                    if ( isset( $_GET['add'] )) :
                    ?>
                    <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                        <?php _e( 'Successfully send a ticket.' ); ?>
                    </div>
                    <?php
                    endif;
                    ?>
                    
                    <div class="ipadm-body">
                        
                        <div class="ipadm-main">
                            <div class="ipadm-manage clearfix">
                                <div class="ipadm-table">
                                    <?php
                                    require_once( plugin_dir_path( __FILE__ ) . "table-ticket.php" );
                                    $paginArgs = array(
                                        "per_page" => 20 
                                    );
                                    $listTable = new IPTrac_TableTicket();
                                    $listTable->prepare_items();
                                    $listTable->display();
                                    ?>
                                </div>
                                
                            </div>
                        </div>
                        
                    </div>
                    
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content editing ticket page
         *
         * @return void
         */
        public function userTicketEdit()
        {
            global $user_ID;
            
            $model = new IPTrac_Model();
            if ( empty( $_GET['id'] )) {
                wp_die( __('You do not have sufficient permissions to access this page.', 'wpiptrac') );
            }
            $id = absint( $_GET['id'] );
            if ( ! $ticket = $model->getTicket( $id, $user_ID ) ) {
                wp_die( __('You do not have sufficient permissions to access this page.', 'wpiptrac') );
            }
        ?>
            <div id="iptrac-manage-ticket" class="wrap ipadm-wrap iptrac-admin">
                <div class="ipadm-inner">
                    <div class="ipadm-header">
                        <div class="ipadm-page-title">
                            <h1>
                                <i class="fa fa-ticket"></i>
                                <span class="ipadm-title"><?php _e( 'Detail Ticket', 'wpiptrac' ); ?></span>
                            </h1>
                        </div>
                    </div>
                    
                    <?php
                    if ( isset( $_GET['update'] ) && $_GET['update'] == 1 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                            <?php _e( 'Successfully editing ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    elseif ( isset( $_GET['update'] ) && $_GET['update'] == 0 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-error" style="display: block;">
                            <?php _e( 'Failed editing ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    elseif ( isset( $_GET['close'] ) && $_GET['close'] == 1 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                            <?php _e( 'Successfully closing ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    elseif ( isset( $_GET['close'] ) && $_GET['close'] == 0 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-error" style="display: block;">
                            <?php _e( 'Failed closing ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    elseif ( isset( $_GET['reopen'] ) && $_GET['reopen'] == 1 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                            <?php _e( 'Successfully reopening ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    elseif ( isset( $_GET['reopen'] ) && $_GET['reopen'] == 0 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-error" style="display: block;">
                            <?php _e( 'Failed reopening ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    elseif ( isset( $_GET['add'] ) && $_GET['add'] == 1 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                            <?php _e( 'Successfully create new ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    endif;
                    ?>
                    
                    <div class="ipadm-body">
                        
                        <div class="ipadm-main">

<div id="iptrac-ticket-info">
    <div class="iptrac-info-header ipadm-clear">
        <h3>#<?php echo $ticket->tick_id; ?></h3>
        <?php 
        if ( $ticket->tick_status != 4 ) :
        ?>
        <div class="iptrac-ticket-edit">
            <a href="#" id="iptrac-ticket-btn-edit" class="button"><i class="fa fa-pencil"></i> <?php _e( 'Edit', 'wpiptrac' ); ?></a>
        </div>
        <?php 
        endif;
        ?>
    </div>
    <div class="iptrac-info-content ipadm-clear">
        <div class="iptrac-info-main">
        <div class="iptrac-inner">
            <div class="iptrac-info-meta">
                <div class="iptrac-meta-label">
                    <strong><?php _e( 'Summary', 'wpiptrac' ); ?></strong>
                </div>
                <div class="iptrac-meta-value">
                    <?php echo $ticket->tick_summary; ?>
                </div>
            </div>
            <div class="iptrac-info-meta">
                <div class="iptrac-meta-label">
                    <strong><?php _e( 'Description', 'wpiptrac' ); ?></strong>
                </div>
                <div class="iptrac-meta-value">
                    <?php echo $ticket->tick_desc; ?>
                </div>
            </div>
            <div class="iptrac-meta-2span ipadm-clear">
                <div class="iptrac-info-meta">
                    <div class="iptrac-meta-label">
                        <strong><?php _e( 'Product', 'wpiptrac' ); ?></strong>
                    </div>
                    <div class="iptrac-meta-value">
                        <?php echo $ticket->prod_title; ?>
                    </div>
                </div>
                <div class="iptrac-info-meta">
                    <div class="iptrac-meta-label">
                        <strong><?php _e( 'Version', 'wpiptrac' ); ?></strong>
                    </div>
                    <div class="iptrac-meta-value">
                        <?php echo $ticket->vers_label; ?>
                    </div>
                </div>
                <div class="iptrac-info-meta">
                    <div class="iptrac-meta-label">
                        <strong><?php _e( 'Staff', 'wpiptrac' ); ?></strong>
                    </div>
                    <div class="iptrac-meta-value">
                        <?php echo $ticket->user_login; ?>
                    </div>
                </div>
                <div class="iptrac-info-meta">
                    <div class="iptrac-meta-label">
                        <strong><?php _e( 'Type', 'wpiptrac' ); ?></strong>
                    </div>
                    <div class="iptrac-meta-value">
                        <?php echo $ticket->type_label; ?>
                    </div>
                </div>
                <div class="iptrac-info-meta">
                    <div class="iptrac-meta-label">
                        <strong><?php _e( 'Focus', 'wpiptrac' ); ?></strong>
                    </div>
                    <div class="iptrac-meta-value">
                        <?php echo $ticket->focus_label; ?>
                    </div>
                </div>
            </div>
        </div>
        </div>
        <div class="iptrac-ticket-actions">
        <div class="iptrac-inner">
            <ul class="iptrac-ticket-status">
                <li>
                    <i class="fa fa-signal"></i> <span><?php _e( 'Status', 'wpiptrac' ); ?> :</span>
                    <strong>
                        <?php
                        $label  = __( 'Invalid', 'wpiptrac' );
                        $status = $ticket->tick_status;
                        if ( $status == 1 ) {
                            $label = __( 'Awaiting Review', 'wpiptrac' );
                        } elseif ( $status == 2 ) {
                            $label = __( 'Active', 'wpiptrac' );
                        } elseif ( $status == 3 ) {
                            $label = __( 'Closed', 'wpiptrac' );
                        } elseif ( $status == 4 ) {
                            $label = __( 'Rejected', 'wpiptrac' );
                        }
                        echo $label;
                        ?>
                    </strong>
                </li>
                <li>
                    <i class="fa fa-clock-o"></i> <span><?php _e( 'Opened', 'wpiptrac' ); ?> :</span>
                    <strong>
                        <?php echo mysql2date( 'd F Y, h:i', $ticket->tick_created ); ?>
                    </strong>
                </li>
                <li>
                    <i class="fa fa-clock-o"></i> <span><?php _e( 'Last Modified', 'wpiptrac' ); ?> :</span>
                    <strong>
                        <?php echo mysql2date( 'd F Y, h:i', $ticket->tick_modified ); ?>
                    </strong>
                </li>
            </ul>
            <div class="ipadm-btn-wrap">
                <?php 
                if ( $ticket->tick_status == 3 ) :
                ?>
                <a id="iptrac-do-ticket-reopen" class="ipadm-btn ipadm-btn-large ipadm-btn-success" data-user-type="2" href="#ticket_<?php echo $ticket->tick_id; ?>">
                    <?php _e( 'Reopen Ticket', 'wpiptrac' ); ?>
                </a>
                <?php 
                elseif ( $ticket->tick_status == 2 ) :
                ?>
                <a id="iptrac-do-ticket-close" class="ipadm-btn ipadm-btn-large ipadm-btn-danger" data-user-type="2" href="#ticket_<?php echo $ticket->tick_id; ?>">
                    <?php _e( 'Close Ticket', 'wpiptrac' ); ?>
                </a>
                <?php 
                endif;
                ?>
            </div>
        </div>
        </div>
    </div>
</div>

<div id="iptrac-ticket-attachment">
    <div class="ipadm-section-title">
        <h3><i class="fa fa-download"></i> <?php _e( 'Attachment', 'wpiptrac' ); ?></h3>
    </div>
    <div class="iptrac-attach-list">
        
        <?php 
        if ( $files = $model->getAttachments( $ticket->tick_id ) ) :
        ?>
        <div id="iptrac-file-list-values">
            <ul>
            <?php
            foreach( $files as $file ) :
            
                $name = '';
                if ( ! empty( $file->post_title )) {
                    $name = $file->post_title;
                } elseif ( ! empty( $file->post_name )) {
                    $name = $file->post_name;
                }
            ?>
            <li id="iptrac-file-<?php echo $file->att_id; ?>" class="iptrac-file-item">
                <div class="iptrac-file-label">
                    <i class="fa fa-file"></i>
                    <strong><?php echo $name; ?></strong>
                </div>
                <div class="iptrac-file-actions">
                    <a target="__blank" class="iptrac-file-download" href="<?php echo $file->guid; ?>"><i class="fa fa-download"></i> Download</a>
                    <a class="iptrac-file-edit" href="#"><i class="fa fa-pencil"></i> Edit</a>
                    <a class="iptrac-file-delete" href="#"><i class="fa fa-trash-o"></i> Delete</a>
                </div>
            </li>
            <?php
            endforeach;
            ?>
            </ul>
        </div>
        <div id="iptrac-file-list-empty" style="display:none;">
            <p class="ipadm-empty"><em><?php _e( 'File not found', 'wpiptrac' ); ?></em></p>
        </div>
        <?php
        else :
        ?>
        <div id="iptrac-file-list-values" style="display:none;">
            <ul></ul>
        </div>
        <div id="iptrac-file-list-empty">
            <p class="ipadm-empty"><em><?php _e( 'File not found', 'wpiptrac' ); ?></em></p>
        </div>
        <?php
        endif;
        
        if ( $ticket->tick_status != 4 ) :
        ?>
        <div class="iptrac-add-file">
            <a id="iptrac-show-upload-modal" href="#" class="button"><i class="fa fa-cloud-upload"></i> Add File</a>
        </div>
        <?php 
        endif;
        ?>
    </div>
</div>

<div id="iptrac-ticket-history">
    <div class="ipadm-section-title">
        <h3><i class="fa fa-calendar"></i> <?php _e( 'History', 'wpiptrac' ); ?></h3>
    </div>
    <div class="iptrac-histories">
    
        <?php 
        if ( $histories = $model->getHistories( $ticket->tick_id ) ) :
        ?>
        <div class="iptrac-history-list">
            <ul>
            <?php
            foreach( $histories as $history ) :
                
                $class = 'iptrac-history-item';
                if ( $history->hist_user_type == 2 ) {
                    $class .= ' iptrac-history-user';
                } else {
                    $class .= ' iptrac-history-admin';
                }
            ?>
                <li id="iptrac-history-<?php echo $history->hist_id; ?>" class="<?php echo $class; ?>">
                    <div class="iptrac-history-top ipadm-clear">
                        <div class="iptrac-history-date">
                            <?php echo mysql2date( 'd F Y, h:i', $history->hist_date ); ?>
                        </div>
                        <div class="iptrac-history-author">
                            <?php printf( __( 'Action by <strong>%s</strong>', 'wpiptrac' ), $history->user_login ); ?>
                        </div>
                    </div>
                    <div class="iptrac-history-main">
                        <div class="iptrac-history-title">
                            <strong>
                            <?php
                            $type = $history->hist_type;
                            if ( $type == 1 ) {
                                printf( 
                                    __( '<span class="iptrac-user">%s</span> send ticket: <span class="iptrac-hist-value">#%s - %s</span>', 'wpiptrac' ), 
                                    $history->user_login,
                                    $history->tick_id,
                                    $history->hist_message
                                );
                            }
                            elseif ( $type == 2 ) {
                                printf( 
                                    __( '<span class="iptrac-user">%s</span> accept ticket: <span class="iptrac-hist-value">#%s - %s</span>', 'wpiptrac' ), 
                                    $history->user_login,
                                    $history->tick_id,
                                    $history->hist_message
                                );
                            }
                            elseif ( $type == 3 ) {
                                printf( 
                                    __( '<span class="iptrac-user">%s</span> close ticket: <span class="iptrac-hist-value">#%s - %s</span>', 'wpiptrac' ), 
                                    $history->user_login,
                                    $history->tick_id,
                                    $history->hist_message
                                );
                            }
                            elseif ( $type == 4 ) {
                                printf( 
                                    __( '<span class="iptrac-user">%s</span> reopen ticket: <span class="iptrac-hist-value">#%s - %s</span>', 'wpiptrac' ), 
                                    $history->user_login,
                                    $history->tick_id,
                                    $history->hist_message
                                );
                            }
                            elseif ( $type == 5 ) {
                                printf( __( '<span class="iptrac-user">%s</span> send a message', 'wpiptrac' ), $history->user_login );
                            }
                            elseif ( $type == 6 ) {
                                $file = $history->hist_message;
                                if ( ! empty( $file )) {
                                    printf( __( '<span class="iptrac-user">%s</span> upload file <span class="iptrac-hist-value">%s</span>', 'wpiptrac' ), $history->user_login, $file );
                                } else {
                                    printf( __( '<span class="iptrac-user">%s</span> upload a file', 'wpiptrac' ), $history->user_login );
                                }
                            }
                            elseif ( $type == 7 ) {
                                $file = $history->hist_message;
                                if ( ! empty( $file )) {
                                    printf( __( '<span class="iptrac-user">%s</span> delete file <span class="iptrac-hist-value">%s</span>', 'wpiptrac' ), $history->user_login, $file );
                                } else {
                                    printf( __( '<span class="iptrac-user">%s</span> delete a file', 'wpiptrac' ), $history->user_login );
                                }
                            }
                            elseif ( $type == 8 ) {
                                printf( 
                                    __( '<span class="iptrac-user">%s</span> reject ticket: <span class="iptrac-hist-value">#%s - %s</span>', 'wpiptrac' ), 
                                    $history->user_login,
                                    $history->tick_id,
                                    $history->hist_message
                                );
                            }
                            ?>
                            </strong>
                        </div>
                        <?php 
                        if ( $type == 5 && ! empty( $history->hist_message )) :
                        ?>
                        <div class="iptrac-history-message">
                            <h4><?php _e( 'Message', 'wpiptrac' ); ?></h4>
                            <div class="iptrac-message-content">
                                <?php
                                echo $history->hist_message;
                                ?>
                            </div>
                        </div>
                        <?php 
                        endif;
                        ?>
                    </div>
                </li>
            <?php
            endforeach;
            ?>
            </ul>
        </div>
        <?php
        else :
        ?>
        <div class="iptrac-history-empty">
            <p class="ipadm-empty"><em><?php _e( 'Ticket histories not found', 'wpiptrac' ); ?></em></p>
        </div>
        <?php
        endif;
        
        if ( $ticket->tick_status != 4 ) :
        ?>
        <div class="iptrac-add-file">
            <a id="iptrac-show-message-modal" href="#" class="ipadm-btn ipadm-btn-primary"><i class="fa fa-envelope"></i> Send Message</a>
        </div>
        <?php 
        endif;
        ?>
    </div>
</div>

                        </div>
                    </div>
                </div>

<div class="iptrac-modals-wrap">

    <div id="iptrac-ticket-modal" class="iptrac-modal" style="display: none;">
        <div class="iptrac-modal-inner">
            <div id="iptrac-ticket-modal-content" class="iptrac-modal-main">
            
                <div class="iptrac-modal-close">
                    <a class="iptrac-modal-close-link" href="#">x</a>
                </div>
                
                <h3 class="iptrac-modal-title"><?php _e( 'Edit Ticket', 'wpiptrac' ); ?></h3>
                <div class="iptrac-modal-content">

<form id="iptrac-form-send-ticket" action="" method="post">

    <input type="hidden" name="ticket_id" id="value-ticket-id" value="<?php echo $ticket->tick_id; ?>" />
    <input type="hidden" name="user_type" class="value-user-type" value="2" />

    <div class="ipadm-form-main iptrac-onecolumn">
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-summary"><?php _e( 'Summary', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <input type="text" class="ipadm-input ipadm-input-widest" id="input-summary" name="summary" value="<?php echo $ticket->tick_summary; ?>" />
            </div>
        </div>
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-description"><?php _e( 'Description', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <?php
                $content = $ticket->tick_desc;
                wp_editor( $content, 'description', array( 
                    'editor_height' => 200,
                )); 
                ?>
            </div>
        </div>
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-product"><?php _e( 'Product', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <select name="product" id="input-product">
                    <?php 
                    $selectProd = $ticket->prod_id;
                    if ( $products = $model->getProducts() ) {
                        foreach( $products as $product ) 
                        {
                            $sltd = '';
                            if ( $selectProd == $product->prod_id ) {
                                $sltd = ' selected="selected"';
                            }
                            echo '<option value="' . $product->prod_id . '"' . $sltd . '>' . $product->prod_title . '</option>';
                        }
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-version"><?php _e( 'Version', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <select name="version" id="input-version">
                    <?php 
                    if ( ! empty( $selectProd )) 
                    {
                        $select = $ticket->vers_id;
                        if ( $versions = $model->getVersions( $selectProd ) ) 
                        {
                            foreach( $versions as $version ) 
                            {
                                $sltd = '';
                                if ( $select == $version->vers_id ) {
                                    $sltd = ' selected="selected"';
                                }
                                echo '<option value="' . $version->vers_id . '"' . $sltd . '>' . $version->vers_label . '</option>';
                            }
                        }
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-type"><?php _e( 'Type', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <select name="type" id="input-type">
                    <?php 
                    $select = $ticket->type_id;
                    if ( $types = $model->getTypes() ) {
                        foreach( $types as $type ) 
                        {
                            $sltd = '';
                            if ( $select == $type->type_id ) {
                                $sltd = ' selected="selected"';
                            }
                            echo '<option value="' . $type->type_id . '"' . $sltd . '>' . $type->type_label . '</option>';
                        }
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div id="iptrac-field-attachment" class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-focus"><?php _e( 'Focus', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <select name="focus" id="input-focus">
                    <?php 
                    $select = $ticket->focus_id;
                    if ( $focuses = $model->getFocuses() ) {
                        foreach( $focuses as $focus ) 
                        {
                            $sltd = '';
                            if ( $select == $focus->focus_id ) {
                                $sltd = ' selected="selected"';
                            }
                            echo '<option value="' . $focus->focus_id . '"' .$sltd . '>' . $focus->focus_label . '</option>';
                        }
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-staff"><?php _e( 'Staff', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <select name="staff" id="input-staff">
                    <?php 
                    $select    =  $ticket->staff_id;
                    $userQuery = new WP_User_Query( array( 'role' => 'Administrator' ) );
                    if ( $users = $userQuery->get_results() ) {
                        foreach( $users as $user ) {
                            $name = '';
                            if ( ! empty( $user->user_name )) {
                                $name = $user->user_name;
                            }
                            elseif ( ! empty( $user->user_nicename )) {
                                $name = $user->user_nicename;
                            }
                            elseif ( ! empty( $user->user_login )) {
                                $name = $user->user_login;
                            }
                            $sltd = '';
                            if ( $select == $user->ID ) {
                                $sltd = ' selected="selected"';
                            }
                            echo '<option value="' . $user->ID . '"' .$sltd . '>' . $name . '</option>';
                        }
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div class="ipadm-btn-wrap">
            <input type="submit" id="iptrac-edit-ticket" name="do_edit_ticket" class="ipadm-btn ipadm-btn-primary ipadm-btn-large" value="Edit ticket" />
        </div>
        
    </div>

</form>

                </div>
            </div>
        </div>
    </div>

    <div id="iptrac-add-modal" class="iptrac-modal" style="display: none;">
        <div class="iptrac-modal-inner">
            <div id="iptrac-add-att-content" class="iptrac-modal-main">
            
                <div class="iptrac-modal-close">
                    <a class="iptrac-modal-close-link" href="#">x</a>
                </div>
                
                <h3 id="iptrac-attach-add-title" class="iptrac-modal-title"><?php _e( 'Add Attachment', 'wpiptrac' ); ?></h3>
                <h3 id="iptrac-attach-edit-title" class="iptrac-modal-title" style="display:none;"><?php _e( 'Edit Attachment', 'wpiptrac' ); ?></h3>
                
                <div class="iptrac-modal-content">
                    
                    <div class="ipadm-main">
                        <div class="ipadm-form-wrap">
                            <form id="iptrac-form-add-attach" action="" method="post" enctype="multipart/form-data">
            
                                <input type="hidden" id="value-ticket-id" name="ticket_id" value="<?php echo $ticket->tick_id; ?>" />
                                <input type="hidden" id="value-attach-id" name="attach_id" value="0" />
                                
                                <div class="fields">
                                    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                                        <div class="ipadm-label">
                                            <label for="input-attach-file"><?php _e( 'File', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
                                        </div>
                                        <div class="ipadm-field">
                                            <div class="iptrac-file-input">
                                                <input type="file" name="attach_file" id="input-attach-file" />
                                            </div>
                                        </div>
                                    </div>
                                    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                                        <div class="ipadm-label">
                                            <label for="input-file-title"><?php _e( 'Title', 'wpiptrac' ); ?></label>
                                        </div>
                                        <div class="ipadm-field">
                                            <input type="text" class="ipadm-input ipadm-input-widest" name="file_title" id="input-file-title" value="" />
                                        </div>
                                    </div>
                                    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                                        <div class="ipadm-label">
                                            <label for="input-file-desc"><?php _e( 'Description', 'wpiptrac' ); ?></label>
                                        </div>
                                        <div class="ipadm-field">
                                            <textarea class="ipadm-input ipadm-input-widest" id="input-file-desc" name="file_desc" rows="8"></textarea>
                                        </div>
                                    </div>
                                </div>
                                
                                <div class="ipadm-btn-wrap iptrac-form-actions">
                                    <input type="submit" class="ipadm-btn ipadm-btn-primary" id="iptrac-do-add-attach" name="do_add_attach" value="Add attachment" />
                                    <input type="submit" class="ipadm-btn ipadm-btn-primary" id="iptrac-do-edit-attach" name="do_edit_attach" value="Edit attachment" style="display: none;" />
                                    <a href="#" class="ipadm-btn ipadm-btn-default iptrac-modal-cancel">Cancel</a>
                                </div>
                
                            </form>
                        </div>
                    </div>
                    
                </div>
                
            </div>
        </div>
    </div>

    <div id="iptrac-msg-modal" class="iptrac-modal" style="display: none;">
        <div class="iptrac-modal-inner">
            <div id="iptrac-msg-modal-content" class="iptrac-modal-main">
            
                <div class="iptrac-modal-close">
                    <a class="iptrac-modal-close-link" href="#">x</a>
                </div>
                
                <h3 class="iptrac-modal-title"><?php _e( 'Send Message', 'wpiptrac' ); ?></h3>
                
                <div class="iptrac-modal-content">
                
<form id="iptrac-form-send-msg" action="" method="post">

    <input type="hidden" name="ticket_id" id="value-ticket-id" value="<?php echo $ticket->tick_id; ?>" />
    <input type="hidden" name="user_type" class="value-user-type" value="2" />

    <div class="ipadm-form-main iptrac-onecolumn">
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-field" style="margin-left: 0;">
                <?php
                $content = '';
                wp_editor( $content, 'message', array( 
                    'editor_height' => 500,
                )); 
                ?>
            </div>
        </div>
        
        <div class="ipadm-btn-wrap">
            <input type="submit" id="iptrac-send-message" name="do_send_message" class="ipadm-btn ipadm-btn-primary ipadm-btn-large" value="Send message" />
        </div>
    </div>
</form>
                </div>
            </div>
        </div>
    </div>
    
    <div id="iptrac-modal-loader-overlay" style="display:none;">
        <div id="iptrac-modal-loader"></div>
    </div>

    <div id="iptrac-modal-message-overlay" style="display:none;">
        <div id="iptrac-modal-message"></div>
    </div>
</div>
            </div>
        <?php 
        }
        
        /**
         * Show content manage ticket page
         *
         * @return void
         */
        public function adminTicket()
        {
            $action = 'manage';
            if ( ! empty( $_GET['action'] )) {
                $action = trim( $_GET['action'] );
            }
            if ( $action == 'edit' ) {
                $this->adminTicketEdit();
            }
            elseif ( $action == 'all' ) {
                $this->adminAllTicketManage();
            }
            else {
                $this->adminTicketManage();
            }
        }
        
        /**
         * Show content manage ticket page
         *
         * @return void
         */
        public function adminTicketManage()
        {
            wp_enqueue_script('jquery-ui-datepicker');
            
            $model  = new IPTrac_Model();
            $plgurl = plugin_dir_url( dirname(__FILE__) );
        ?>
            <div id="iptrac-manage-ticket" class="wrap ipadm-wrap iptrac-admin">
                <div class="ipadm-inner">
                    
                    <div class="ipadm-header">
                        <div class="ipadm-page-title">
                            <h1>
                                <i class="fa fa-ticket"></i>
                                <span class="ipadm-title"><?php _e( 'Tickets', 'wpiptrac' ); ?></span>
                            </h1>
                        </div>
                    </div>
                    
                    <?php
                    if ( isset( $_GET['add'] )) :
                    ?>
                    <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                        <?php _e( 'Successfully send a ticket.' ); ?>
                    </div>
                    <?php
                    endif;
                    ?>
                    
                    <div class="ipadm-body">
                        
                        <div class="ipadm-main">
                            <div class="ipadm-manage">
                            
                                <div class="iptrac-tabs">
                                    <ul class="ipadm-clear">
                                        <li class="iptrac-selected">
                                            <a href="admin.php?page=iptrac-admin-manage">Your Tickets</a>
                                        </li>
                                        <li>
                                            <a href="admin.php?page=iptrac-admin-manage&action=all">All Tickets</a>
                                        </li>
                                    </ul>
                                </div>
                                
                                <div class="iptrac-ticket-table ipadm-clear">

<link media="all" type="text/css" href="<?php echo $plgurl; ?>css/datepicker.css" rel="stylesheet">
<div class="iptrac-filter">
    <form action="" method="get">
        <input type="hidden" name="page" value="iptrac-admin-manage" />
        <h3><?php _e( 'Filter Tickets', 'wpiptrac'); ?></h3>
        <div class="filter-section">
            <h4><?php _e( 'User', 'wpiptrac' ); ?></h4>
            <div class="filter-options">
                <?php
                $selects = array();
                if ( isset( $_GET['user'] )) {
                    $selects = $_GET['user'];
                }
                if ( $users = get_users( array( 'role' => 'Subscriber' ) ) ) :
                ?>
                <ul>
                    <li>
                        <label>
                            <?php
                            $checkAll = ' checked="checked"';
                            if ( isset( $_GET['dofilter'] ) && ! isset( $_GET['user_all'] )) {
                                $checkAll = '';
                            }
                            ?>
                            <input class="iptrac-input-all" type="checkbox" name="user_all" value="0"<?php echo $checkAll; ?>>
                            <?php _e( 'All User', 'wpiptrac' ); ?>
                        </label>
                    </li>
                    <?php
                    foreach( $users as $user ):
                        $check = ' checked="checked"';
                        if ( isset( $_GET['dofilter'] ) && ! in_array( $user->ID, $selects ) && empty( $checkAll )) {
                            $check = '';
                        }
                    ?>
                    <li>
                        <label>
                            <input type="checkbox" name="user[]" value="<?php echo $user->ID; ?>"<?php echo $check; ?>>
                            <?php echo $user->user_nicename; ?>
                        </label>
                    </li>
                    <?php 
                    endforeach;
                    ?>
                </ul>
                <?php
                else :
                ?>
                <p class="none"><?php _e( 'Users not found.', 'wpiptrac' ); ?></p>
                <?php
                endif;
                ?>
            </div>
        </div>
        <div class="filter-section">
            <h4><?php _e( 'Product', 'wpiptrac' ); ?></h4>
            <div class="filter-options">
                <?php
                $selects = array();
                if ( isset( $_GET['product'] )) {
                    $selects = $_GET['product'];
                }
                if ( $products = $model->getProducts() ) :
                ?>
                <ul>
                    <li>
                        <label>
                            <?php
                            $checkAll = ' checked="checked"';
                            if ( isset( $_GET['dofilter'] ) && ! isset( $_GET['product_all'] )) {
                                $checkAll = '';
                            }
                            ?>
                            <input class="iptrac-input-all" type="checkbox" name="product_all" value="0"<?php echo $checkAll; ?>>
                            <?php _e( 'All Product', 'wpiptrac' ); ?>
                        </label>
                    </li>
                    <?php
                    foreach( $products as $product ):
                        $check = ' checked="checked"';
                        if ( isset( $_GET['dofilter'] ) && ! in_array( $product->prod_id, $selects ) && empty( $checkAll )) {
                            $check = '';
                        }
                    ?>
                    <li>
                        <label>
                            <input type="checkbox" name="product[]" value="<?php echo $product->prod_id; ?>"<?php echo $check; ?>>
                            <?php echo $product->prod_title; ?>
                        </label>
                    </li>
                    <?php 
                    endforeach;
                    ?>
                </ul>
                <?php
                else :
                ?>
                <p class="none"><?php _e( 'Products not found.', 'wpiptrac' ); ?></p>
                <?php
                endif;
                ?>
            </div>
        </div>
        <div class="filter-section">
            <h4><?php _e( 'Type', 'wpiptrac' ); ?></h4>
            <div class="filter-options">
                <?php
                $selects = array();
                if ( isset( $_GET['type'] )) {
                    $selects = $_GET['type'];
                }
                if ( $types = $model->getTypes() ) :
                ?>
                <ul>
                    <li>
                        <label>
                            <?php
                            $checkAll = ' checked="checked"';
                            if ( isset( $_GET['dofilter'] ) && ! isset( $_GET['type_all'] )) {
                                $checkAll = '';
                            }
                            ?>
                            <input class="iptrac-input-all" type="checkbox" name="type_all" value="0"<?php echo $checkAll; ?>>
                            <?php _e( 'All Type', 'wpiptrac' ); ?>
                        </label>
                    </li>
                    <?php
                    foreach( $types as $type ):
                        $check = ' checked="checked"';
                        if ( isset( $_GET['dofilter'] ) && ! in_array( $type->type_id, $selects ) && empty( $checkAll )) {
                            $check = '';
                        }
                    ?>
                    <li>
                        <label>
                            <input type="checkbox" name="type[]" value="<?php echo $type->type_id; ?>"<?php echo $check; ?>>
                            <?php echo $type->type_label; ?>
                        </label>
                    </li>
                    <?php 
                    endforeach;
                    ?>
                </ul>
                <?php
                else :
                ?>
                <p class="none"><?php _e( 'Focuses not found.', 'wpiptrac' ); ?></p>
                <?php
                endif;
                ?>
            </div>
        </div>
        <div class="filter-section">
            <h4><?php _e( 'Focus', 'wpiptrac' ); ?></h4>
            <div class="filter-options">
                <?php
                $selects = array();
                if ( isset( $_GET['focus'] )) {
                    $selects = $_GET['focus'];
                }
                if ( $focuses = $model->getFocuses() ) :
                ?>
                <ul>
                    <li>
                        <label>
                            <?php
                            $checkAll = ' checked="checked"';
                            if ( isset( $_GET['dofilter'] ) && ! isset( $_GET['focus_all'] )) {
                                $checkAll = '';
                            }
                            ?>
                            <input class="iptrac-input-all" type="checkbox" name="focus_all" value="0"<?php echo $checkAll; ?>>
                            <?php _e( 'All Focus', 'wpiptrac' ); ?>
                        </label>
                    </li>
                    <?php
                    foreach( $focuses as $focus ):
                        $check = ' checked="checked"';
                        if ( isset( $_GET['dofilter'] ) && ! in_array( $focus->focus_id, $selects ) && empty( $checkAll )) {
                            $check = '';
                        }
                    ?>
                    <li>
                        <label>
                            <input type="checkbox" name="focus[]" value="<?php echo $focus->focus_id; ?>"<?php echo $check; ?>>
                            <?php echo $focus->focus_label; ?>
                        </label>
                    </li>
                    <?php 
                    endforeach;
                    ?>
                </ul>
                <?php
                else :
                ?>
                <p class="none"><?php _e( 'Focuses not found.', 'wpiptrac' ); ?></p>
                <?php
                endif;
                ?>
            </div>
        </div>
        <div class="filter-section">
            <h4><?php _e( 'Date', 'wpiptrac' ); ?></h4>
            <div class="filter-options">
                <?php 
                $start = '';
                if ( ! empty( $_GET['date_start'] )) {
                    $start = $_GET['date_start'];
                }
                $end = '';
                if ( ! empty( $_GET['date_end'] )) {
                    $end = $_GET['date_end'];
                }
                ?>
                <input type="text" class="iptrac-input-date" name="date_start" value="<?php echo $start; ?>" />
                -
                <input type="text" class="iptrac-input-date" name="date_end" value="<?php echo $end; ?>" />
            </div>
        </div>
        <div class="filter-section">
            <h4><?php _e( 'Status', 'wpiptrac' ); ?></h4>
            <div class="filter-options">
                <ul>
                    <li>
                        <label>
                            <?php
                            $checkAll = ' checked="checked"';
                            if ( isset( $_GET['dofilter'] ) && ! isset( $_GET['status_all'] )) {
                                $checkAll = '';
                            }
                            ?>
                            <input class="iptrac-input-all" type="checkbox" name="status_all" value="0"<?php echo $checkAll; ?>>
                            <?php _e( 'All Status', 'wpiptrac' ); ?>
                        </label>
                    </li>
                    <?php
                    $selects = array();
                    if ( isset( $_GET['status'] )) {
                        $selects = $_GET['status'];
                    }
                    $statuses = array(
                        1 => __( 'Awaiting Review', 'wpiptrac' ),
                        2 => __( 'Active', 'wpiptrac' ),
                        3 => __( 'Closed', 'wpiptrac' ),
                        4 => __( 'Rejected', 'wpiptrac' ),
                    );
                    foreach( $statuses as $id => $label  ):
                        $check = ' checked="checked"';
                        if ( isset( $_GET['dofilter'] ) && ! in_array( $id, $selects ) && empty( $checkAll )) {
                            $check = '';
                        }
                    ?>
                    <li>
                        <label>
                            <input type="checkbox" name="status[]" value="<?php echo $id; ?>"<?php echo $check; ?>>
                            <?php echo $label; ?>
                        </label>
                    </li>
                    <?php
                    endforeach;
                    ?>
                </ul>
            </div>
        </div>
        <div class="filter-button">
            <input type="submit" class="button" name="dofilter" id="iptrac-dofilter" value="<?php _e( 'Filter', 'wpiptrac' ); ?>">
        </div>
    </form>
</div>

                                    <div class="iptrac-table ipadm-table">
                                        <?php
                                        require_once( plugin_dir_path( __FILE__ ) . "table-staff-ticket.php" );
                                        $paginArgs = array(
                                            "per_page" => 20 
                                        );
                                        $listTable = new IPTrac_TableStaffTicket();
                                        $listTable->prepare_items();
                                        $listTable->display();
                                        ?>
                                    </div>


                                </div>
                                
                            </div>
                        </div>
                        
                    </div>
                    
                </div>
            </div>
            <script type="text/javascript">
                (function($){
                    $(document).ready(function() {
                        $( '.iptrac-input-date' )
                            .datepicker()
                            .bind('changeDate', function(ev){
                                $('#date-end').datepicker('hide');
                            });
                    });
                })(jQuery);
            </script>
        <?php
        }
        
        /**
         * Show content manage ticket page
         *
         * @return void
         */
        public function adminAllTicketManage()
        {
            wp_enqueue_script('jquery-ui-datepicker');
            
            $model  = new IPTrac_Model();
            $plgurl = plugin_dir_url( dirname(__FILE__) );
        ?>
            <div id="iptrac-manage-ticket" class="wrap ipadm-wrap iptrac-admin">
                <div class="ipadm-inner">
                    
                    <div class="ipadm-header">
                        <div class="ipadm-page-title">
                            <h1>
                                <i class="fa fa-ticket"></i>
                                <span class="ipadm-title"><?php _e( 'Tickets', 'wpiptrac' ); ?></span>
                            </h1>
                        </div>
                    </div>
                    
                    <?php
                    if ( isset( $_GET['add'] )) :
                    ?>
                    <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                        <?php _e( 'Successfully send a ticket.' ); ?>
                    </div>
                    <?php
                    endif;
                    ?>
                    
                    <div class="ipadm-body">
                        
                        <div class="ipadm-main">
                            <div class="ipadm-manage">
                            
                                <div class="iptrac-tabs">
                                    <ul class="ipadm-clear">
                                        <li>
                                            <a href="admin.php?page=iptrac-admin-manage">Your Tickets</a>
                                        </li>
                                        <li class="iptrac-selected">
                                            <a href="admin.php?page=iptrac-admin-manage&action=all">All Tickets</a>
                                        </li>
                                    </ul>
                                </div>
                                
                                
                                <div class="iptrac-ticket-table ipadm-clear">

<link media="all" type="text/css" href="<?php echo $plgurl; ?>css/datepicker.css" rel="stylesheet">
<div class="iptrac-filter">
    <form action="" method="get">
        <input type="hidden" name="page" value="iptrac-admin-manage" />
        <h3><?php _e( 'Filter Tickets', 'wpiptrac'); ?></h3>
        <div class="filter-section">
            <h4><?php _e( 'User', 'wpiptrac' ); ?></h4>
            <div class="filter-options">
                <?php
                $selects = array();
                if ( isset( $_GET['user'] )) {
                    $selects = $_GET['user'];
                }
                if ( $users = get_users( array( 'role' => 'Subscriber' ) ) ) :
                ?>
                <ul>
                    <li>
                        <label>
                            <?php
                            $checkAll = ' checked="checked"';
                            if ( isset( $_GET['dofilter'] ) && ! isset( $_GET['user_all'] )) {
                                $checkAll = '';
                            }
                            ?>
                            <input class="iptrac-input-all" type="checkbox" name="user_all" value="0"<?php echo $checkAll; ?>>
                            <?php _e( 'All User', 'wpiptrac' ); ?>
                        </label>
                    </li>
                    <?php
                    foreach( $users as $user ):
                        $check = ' checked="checked"';
                        if ( isset( $_GET['dofilter'] ) && ! in_array( $user->ID, $selects ) && empty( $checkAll )) {
                            $check = '';
                        }
                    ?>
                    <li>
                        <label>
                            <input type="checkbox" name="user[]" value="<?php echo $user->ID; ?>"<?php echo $check; ?>>
                            <?php echo $user->user_nicename; ?>
                        </label>
                    </li>
                    <?php 
                    endforeach;
                    ?>
                </ul>
                <?php
                else :
                ?>
                <p class="none"><?php _e( 'Users not found.', 'wpiptrac' ); ?></p>
                <?php
                endif;
                ?>
            </div>
        </div>
        <div class="filter-section">
            <h4><?php _e( 'Product', 'wpiptrac' ); ?></h4>
            <div class="filter-options">
                <?php
                $selects = array();
                if ( isset( $_GET['product'] )) {
                    $selects = $_GET['product'];
                }
                if ( $products = $model->getProducts() ) :
                ?>
                <ul>
                    <li>
                        <label>
                            <?php
                            $checkAll = ' checked="checked"';
                            if ( isset( $_GET['dofilter'] ) && ! isset( $_GET['product_all'] )) {
                                $checkAll = '';
                            }
                            ?>
                            <input class="iptrac-input-all" type="checkbox" name="product_all" value="0"<?php echo $checkAll; ?>>
                            <?php _e( 'All Product', 'wpiptrac' ); ?>
                        </label>
                    </li>
                    <?php
                    foreach( $products as $product ):
                        $check = ' checked="checked"';
                        if ( isset( $_GET['dofilter'] ) && ! in_array( $product->prod_id, $selects ) && empty( $checkAll )) {
                            $check = '';
                        }
                    ?>
                    <li>
                        <label>
                            <input type="checkbox" name="product[]" value="<?php echo $product->prod_id; ?>"<?php echo $check; ?>>
                            <?php echo $product->prod_title; ?>
                        </label>
                    </li>
                    <?php 
                    endforeach;
                    ?>
                </ul>
                <?php
                else :
                ?>
                <p class="none"><?php _e( 'Products not found.', 'wpiptrac' ); ?></p>
                <?php
                endif;
                ?>
            </div>
        </div>
        <div class="filter-section">
            <h4><?php _e( 'Type', 'wpiptrac' ); ?></h4>
            <div class="filter-options">
                <?php
                $selects = array();
                if ( isset( $_GET['type'] )) {
                    $selects = $_GET['type'];
                }
                if ( $types = $model->getTypes() ) :
                ?>
                <ul>
                    <li>
                        <label>
                            <?php
                            $checkAll = ' checked="checked"';
                            if ( isset( $_GET['dofilter'] ) && ! isset( $_GET['type_all'] )) {
                                $checkAll = '';
                            }
                            ?>
                            <input class="iptrac-input-all" type="checkbox" name="type_all" value="0"<?php echo $checkAll; ?>>
                            <?php _e( 'All Type', 'wpiptrac' ); ?>
                        </label>
                    </li>
                    <?php
                    foreach( $types as $type ):
                        $check = ' checked="checked"';
                        if ( isset( $_GET['dofilter'] ) && ! in_array( $type->type_id, $selects ) && empty( $checkAll )) {
                            $check = '';
                        }
                    ?>
                    <li>
                        <label>
                            <input type="checkbox" name="type[]" value="<?php echo $type->type_id; ?>"<?php echo $check; ?>>
                            <?php echo $type->type_label; ?>
                        </label>
                    </li>
                    <?php 
                    endforeach;
                    ?>
                </ul>
                <?php
                else :
                ?>
                <p class="none"><?php _e( 'Focuses not found.', 'wpiptrac' ); ?></p>
                <?php
                endif;
                ?>
            </div>
        </div>
        <div class="filter-section">
            <h4><?php _e( 'Focus', 'wpiptrac' ); ?></h4>
            <div class="filter-options">
                <?php
                $selects = array();
                if ( isset( $_GET['focus'] )) {
                    $selects = $_GET['focus'];
                }
                if ( $focuses = $model->getFocuses() ) :
                ?>
                <ul>
                    <li>
                        <label>
                            <?php
                            $checkAll = ' checked="checked"';
                            if ( isset( $_GET['dofilter'] ) && ! isset( $_GET['focus_all'] )) {
                                $checkAll = '';
                            }
                            ?>
                            <input class="iptrac-input-all" type="checkbox" name="focus_all" value="0"<?php echo $checkAll; ?>>
                            <?php _e( 'All Focus', 'wpiptrac' ); ?>
                        </label>
                    </li>
                    <?php
                    foreach( $focuses as $focus ):
                        $check = ' checked="checked"';
                        if ( isset( $_GET['dofilter'] ) && ! in_array( $focus->focus_id, $selects ) && empty( $checkAll )) {
                            $check = '';
                        }
                    ?>
                    <li>
                        <label>
                            <input type="checkbox" name="focus[]" value="<?php echo $focus->focus_id; ?>"<?php echo $check; ?>>
                            <?php echo $focus->focus_label; ?>
                        </label>
                    </li>
                    <?php 
                    endforeach;
                    ?>
                </ul>
                <?php
                else :
                ?>
                <p class="none"><?php _e( 'Focuses not found.', 'wpiptrac' ); ?></p>
                <?php
                endif;
                ?>
            </div>
        </div>
        <div class="filter-section">
            <h4><?php _e( 'Date', 'wpiptrac' ); ?></h4>
            <div class="filter-options">
                <?php 
                $start = '';
                if ( ! empty( $_GET['date_start'] )) {
                    $start = $_GET['date_start'];
                }
                $end = '';
                if ( ! empty( $_GET['date_end'] )) {
                    $end = $_GET['date_end'];
                }
                ?>
                <input type="text" class="iptrac-input-date" name="date_start" value="<?php echo $start; ?>" />
                -
                <input type="text" class="iptrac-input-date" name="date_end" value="<?php echo $end; ?>" />
            </div>
        </div>
        <div class="filter-section">
            <h4><?php _e( 'Status', 'wpiptrac' ); ?></h4>
            <div class="filter-options">
                <ul>
                    <li>
                        <label>
                            <?php
                            $checkAll = ' checked="checked"';
                            if ( isset( $_GET['dofilter'] ) && ! isset( $_GET['status_all'] )) {
                                $checkAll = '';
                            }
                            ?>
                            <input class="iptrac-input-all" type="checkbox" name="status_all" value="0"<?php echo $checkAll; ?>>
                            <?php _e( 'All Status', 'wpiptrac' ); ?>
                        </label>
                    </li>
                    <?php
                    $selects = array();
                    if ( isset( $_GET['status'] )) {
                        $selects = $_GET['status'];
                    }
                    $statuses = array(
                        1 => __( 'Awaiting Review', 'wpiptrac' ),
                        2 => __( 'Active', 'wpiptrac' ),
                        3 => __( 'Closed', 'wpiptrac' ),
                        4 => __( 'Rejected', 'wpiptrac' ),
                    );
                    foreach( $statuses as $id => $label  ):
                        $check = ' checked="checked"';
                        if ( isset( $_GET['dofilter'] ) && ! in_array( $id, $selects ) && empty( $checkAll )) {
                            $check = '';
                        }
                    ?>
                    <li>
                        <label>
                            <input type="checkbox" name="status[]" value="<?php echo $id; ?>"<?php echo $check; ?>>
                            <?php echo $label; ?>
                        </label>
                    </li>
                    <?php
                    endforeach;
                    ?>
                </ul>
            </div>
        </div>
        <div class="filter-button">
            <input type="submit" class="button" name="dofilter" id="iptrac-dofilter" value="<?php _e( 'Filter', 'wpiptrac' ); ?>">
        </div>
    </form>
</div>
                                <div class="iptrac-table ipadm-table">
                                    <?php
                                    require_once( plugin_dir_path( __FILE__ ) . "table-admin-ticket.php" );
                                    $paginArgs = array(
                                        "per_page" => 20 
                                    );
                                    $listTable = new IPTrac_TableAdminTicket();
                                    $listTable->prepare_items();
                                    $listTable->display();
                                    ?>
                                </div>
                                
                                </div>
                                
                            </div>
                        </div>
                        
                    </div>
                    
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content editing ticket page
         *
         * @return void
         */
        public function adminTicketEdit()
        {
            if ( ! current_user_can( 'iptrac_admin_manage' ) ) {
                wp_die( __('You do not have sufficient permissions to access this page.', 'wpiptrac') );
            }
            $model = new IPTrac_Model();
            if ( empty( $_GET['id'] )) {
                wp_die( __('You do not have sufficient permissions to access this page.', 'wpiptrac') );
            }
            $id = absint( $_GET['id'] );
            if ( ! $ticket = $model->getTicket( $id ) ) {
                wp_die( __('You do not have sufficient permissions to access this page.', 'wpiptrac') );
            }
        ?>
            <div id="iptrac-manage-ticket" class="wrap ipadm-wrap iptrac-admin">
                <div class="ipadm-inner">
                    <div class="ipadm-header">
                        <div class="ipadm-page-title">
                            <h1>
                                <i class="fa fa-ticket"></i>
                                <span class="ipadm-title"><?php _e( 'Detail Ticket', 'wpiptrac' ); ?></span>
                            </h1>
                        </div>
                    </div>
                    
                    <?php
                    if ( isset( $_GET['update'] ) && $_GET['update'] == 1 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                            <?php _e( 'Successfully editing ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    elseif ( isset( $_GET['update'] ) && $_GET['update'] == 0 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-error" style="display: block;">
                            <?php _e( 'Failed editing ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    elseif ( isset( $_GET['close'] ) && $_GET['close'] == 1 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                            <?php _e( 'Successfully closing ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    elseif ( isset( $_GET['close'] ) && $_GET['close'] == 0 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-error" style="display: block;">
                            <?php _e( 'Failed closing ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    elseif ( isset( $_GET['reopen'] ) && $_GET['reopen'] == 1 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                            <?php _e( 'Successfully reopening ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    elseif ( isset( $_GET['reopen'] ) && $_GET['reopen'] == 0 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-error" style="display: block;">
                            <?php _e( 'Failed reopening ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    elseif ( isset( $_GET['add'] ) && $_GET['add'] == 1 ) :
                    ?>
                        <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                            <?php _e( 'Successfully create new ticket.', 'wpiptrac' ); ?>
                        </div>
                    <?php
                    endif;
                    ?>
                    
                    <div class="ipadm-body">
                        
                        <div class="ipadm-main">

<div id="iptrac-ticket-info">
    <div class="iptrac-info-header ipadm-clear">
        <h3>#<?php echo $ticket->tick_id; ?></h3>
        <div class="iptrac-ticket-edit">
            <a href="#" id="iptrac-ticket-btn-edit" class="button"><i class="fa fa-pencil"></i> <?php _e( 'Edit', 'wpiptrac' ); ?></a>
        </div>
    </div>
    <div class="iptrac-info-content ipadm-clear">
        <div class="iptrac-info-main">
        <div class="iptrac-inner">
            <div class="iptrac-info-meta">
                <div class="iptrac-meta-label">
                    <strong><?php _e( 'Summary', 'wpiptrac' ); ?></strong>
                </div>
                <div class="iptrac-meta-value">
                    <?php echo $ticket->tick_summary; ?>
                </div>
            </div>
            <div class="iptrac-info-meta">
                <div class="iptrac-meta-label">
                    <strong><?php _e( 'Description', 'wpiptrac' ); ?></strong>
                </div>
                <div class="iptrac-meta-value">
                    <?php echo $ticket->tick_desc; ?>
                </div>
            </div>
            <div class="iptrac-meta-2span ipadm-clear">
                <div class="iptrac-info-meta">
                    <div class="iptrac-meta-label">
                        <strong><?php _e( 'Product', 'wpiptrac' ); ?></strong>
                    </div>
                    <div class="iptrac-meta-value">
                        <?php echo $ticket->prod_title; ?>
                    </div>
                </div>
                <div class="iptrac-info-meta">
                    <div class="iptrac-meta-label">
                        <strong><?php _e( 'Version', 'wpiptrac' ); ?></strong>
                    </div>
                    <div class="iptrac-meta-value">
                        <?php echo $ticket->vers_label; ?>
                    </div>
                </div>
                <div class="iptrac-info-meta">
                    <div class="iptrac-meta-label">
                        <strong><?php _e( 'Staff', 'wpiptrac' ); ?></strong>
                    </div>
                    <div class="iptrac-meta-value">
                        <?php echo $ticket->user_login; ?>
                    </div>
                </div>
                <div class="iptrac-info-meta">
                    <div class="iptrac-meta-label">
                        <strong><?php _e( 'Type', 'wpiptrac' ); ?></strong>
                    </div>
                    <div class="iptrac-meta-value">
                        <?php echo $ticket->type_label; ?>
                    </div>
                </div>
                <div class="iptrac-info-meta">
                    <div class="iptrac-meta-label">
                        <strong><?php _e( 'Focus', 'wpiptrac' ); ?></strong>
                    </div>
                    <div class="iptrac-meta-value">
                        <?php echo $ticket->focus_label; ?>
                    </div>
                </div>
            </div>
        </div>
        </div>
        <div class="iptrac-ticket-actions">
        <div class="iptrac-inner">
            <ul class="iptrac-ticket-status">
                <li>
                    <i class="fa fa-signal"></i> <span><?php _e( 'Status', 'wpiptrac' ); ?> :</span>
                    <strong>
                        <?php
                        $label  = __( 'Invalid', 'wpiptrac' );
                        $status = $ticket->tick_status;
                        if ( $status == 1 ) {
                            $label = __( 'Awaiting Review', 'wpiptrac' );
                        } elseif ( $status == 2 ) {
                            $label = __( 'Active', 'wpiptrac' );
                        } elseif ( $status == 3 ) {
                            $label = __( 'Closed', 'wpiptrac' );
                        } elseif ( $status == 4 ) {
                            $label = __( 'Rejected', 'wpiptrac' );
                        }
                        echo $label;
                        ?>
                    </strong>
                </li>
                <li>
                    <i class="fa fa-clock-o"></i> <span><?php _e( 'Opened', 'wpiptrac' ); ?> :</span>
                    <strong>
                        <?php echo mysql2date( 'd F Y, h:i', $ticket->tick_created ); ?>
                    </strong>
                </li>
                <li>
                    <i class="fa fa-clock-o"></i> <span><?php _e( 'Last Modified', 'wpiptrac' ); ?> :</span>
                    <strong>
                        <?php echo mysql2date( 'd F Y, h:i', $ticket->tick_modified ); ?>
                    </strong>
                </li>
            </ul>
            <div class="ipadm-btn-wrap">
                <?php 
                if ( $ticket->tick_status == 3 || $ticket->tick_status == 4 ) :
                ?>
                <a id="iptrac-do-ticket-reopen" class="ipadm-btn ipadm-btn-large ipadm-btn-success" data-user-type="1" href="#ticket_<?php echo $ticket->tick_id; ?>">
                    <?php _e( 'Reopen Ticket', 'wpiptrac' ); ?>
                </a>
                <?php 
                elseif ( $ticket->tick_status == 2 ) :
                ?>
                <a id="iptrac-do-ticket-close" class="ipadm-btn ipadm-btn-large ipadm-btn-danger" data-user-type="1" href="#ticket_<?php echo $ticket->tick_id; ?>">
                    <?php _e( 'Close Ticket', 'wpiptrac' ); ?>
                </a>
                <?php 
                elseif ( $ticket->tick_status == 1 ) :
                ?>
                <a id="iptrac-do-ticket-accept" class="ipadm-btn ipadm-btn-large ipadm-btn-success" data-user-type="1" href="#ticket_<?php echo $ticket->tick_id; ?>">
                    <?php _e( 'Accept Ticket', 'wpiptrac' ); ?>
                </a>
                <a id="iptrac-do-ticket-reject" class="ipadm-btn ipadm-btn-large ipadm-btn-danger" data-user-type="1" href="#ticket_<?php echo $ticket->tick_id; ?>">
                    <?php _e( 'Reject Ticket', 'wpiptrac' ); ?>
                </a>
                <?php 
                endif;
                ?>
            </div>
        </div>
        </div>
    </div>
</div>

<div id="iptrac-ticket-attachment">
    <div class="ipadm-section-title">
        <h3><i class="fa fa-download"></i> <?php _e( 'Attachment', 'wpiptrac' ); ?></h3>
    </div>
    <div class="iptrac-attach-list">
        
        <?php 
        if ( $files = $model->getAttachments( $ticket->tick_id ) ) :
        ?>
        <div id="iptrac-file-list-values">
            <ul>
            <?php
            foreach( $files as $file ) :
            
                $name = '';
                if ( ! empty( $file->post_title )) {
                    $name = $file->post_title;
                } elseif ( ! empty( $file->post_name )) {
                    $name = $file->post_name;
                }
            ?>
            <li id="iptrac-file-<?php echo $file->att_id; ?>" class="iptrac-file-item">
                <div class="iptrac-file-label">
                    <i class="fa fa-file"></i>
                    <strong><?php echo $name; ?></strong>
                </div>
                <div class="iptrac-file-actions">
                    <a target="__blank" class="iptrac-file-download" href="<?php echo $file->guid; ?>"><i class="fa fa-download"></i> Download</a>
                    <a class="iptrac-file-edit" href="#"><i class="fa fa-pencil"></i> Edit</a>
                    <a class="iptrac-file-delete" href="#"><i class="fa fa-trash-o"></i> Delete</a>
                </div>
            </li>
            <?php
            endforeach;
            ?>
            </ul>
        </div>
        <div id="iptrac-file-list-empty" style="display:none;">
            <p class="ipadm-empty"><em><?php _e( 'File not found', 'wpiptrac' ); ?></em></p>
        </div>
        <?php
        else :
        ?>
        <div id="iptrac-file-list-values" style="display:none;">
            <ul></ul>
        </div>
        <div id="iptrac-file-list-empty">
            <p class="ipadm-empty"><em><?php _e( 'File not found', 'wpiptrac' ); ?></em></p>
        </div>
        <?php
        endif;
        ?>
        <div class="iptrac-add-file">
            <a id="iptrac-show-upload-modal" href="#" class="button"><i class="fa fa-cloud-upload"></i> Add File</a>
        </div>
    </div>
</div>

<div id="iptrac-ticket-history">
    <div class="ipadm-section-title">
        <h3><i class="fa fa-calendar"></i> <?php _e( 'History', 'wpiptrac' ); ?></h3>
    </div>
    <div class="iptrac-histories">
    
        <?php 
        if ( $histories = $model->getHistories( $ticket->tick_id ) ) :
        ?>
        <div class="iptrac-history-list">
            <ul>
            <?php
            foreach( $histories as $history ) :
                
                $class = 'iptrac-history-item';
                if ( $history->hist_user_type == 2 ) {
                    $class .= ' iptrac-history-user';
                } else {
                    $class .= ' iptrac-history-admin';
                }
            ?>
                <li id="iptrac-history-<?php echo $history->hist_id; ?>" class="<?php echo $class; ?>">
                    <div class="iptrac-history-top ipadm-clear">
                        <div class="iptrac-history-date">
                            <?php echo mysql2date( 'd F Y, h:i', $history->hist_date ); ?>
                        </div>
                        <div class="iptrac-history-author">
                            <?php printf( __( 'Action by <strong>%s</strong>', 'wpiptrac' ), $history->user_login ); ?>
                        </div>
                    </div>
                    <div class="iptrac-history-main">
                        <div class="iptrac-history-title">
                            <strong>
                            <?php
                            $type = $history->hist_type;
                            if ( $type == 1 ) {
                                printf( 
                                    __( '<span class="iptrac-user">%s</span> send ticket: <span class="iptrac-hist-value">#%s - %s</span>', 'wpiptrac' ), 
                                    $history->user_login,
                                    $history->tick_id,
                                    $history->hist_message
                                );
                            }
                            elseif ( $type == 2 ) {
                                printf( 
                                    __( '<span class="iptrac-user">%s</span> accept ticket: <span class="iptrac-hist-value">#%s - %s</span>', 'wpiptrac' ), 
                                    $history->user_login,
                                    $history->tick_id,
                                    $history->hist_message
                                );
                            }
                            elseif ( $type == 3 ) {
                                printf( 
                                    __( '<span class="iptrac-user">%s</span> close ticket: <span class="iptrac-hist-value">#%s - %s</span>', 'wpiptrac' ), 
                                    $history->user_login,
                                    $history->tick_id,
                                    $history->hist_message
                                );
                            }
                            elseif ( $type == 4 ) {
                                printf( 
                                    __( '<span class="iptrac-user">%s</span> reopen ticket: <span class="iptrac-hist-value">#%s - %s</span>', 'wpiptrac' ), 
                                    $history->user_login,
                                    $history->tick_id,
                                    $history->hist_message
                                );
                            }
                            elseif ( $type == 5 ) {
                                printf( __( '<span class="iptrac-user">%s</span> send a message', 'wpiptrac' ), $history->user_login );
                            }
                            elseif ( $type == 6 ) {
                                $file = $history->hist_message;
                                if ( ! empty( $file )) {
                                    printf( __( '<span class="iptrac-user">%s</span> upload file <span class="iptrac-hist-value">%s</span>', 'wpiptrac' ), $history->user_login, $file );
                                } else {
                                    printf( __( '<span class="iptrac-user">%s</span> upload a file', 'wpiptrac' ), $history->user_login );
                                }
                            }
                            elseif ( $type == 7 ) {
                                $file = $history->hist_message;
                                if ( ! empty( $file )) {
                                    printf( __( '<span class="iptrac-user">%s</span> delete file <span class="iptrac-hist-value">%s</span>', 'wpiptrac' ), $history->user_login, $file );
                                } else {
                                    printf( __( '<span class="iptrac-user">%s</span> delete a file', 'wpiptrac' ), $history->user_login );
                                }
                            }
                            elseif ( $type == 8 ) {
                                printf( 
                                    __( '<span class="iptrac-user">%s</span> reject ticket: <span class="iptrac-hist-value">#%s - %s</span>', 'wpiptrac' ), 
                                    $history->user_login,
                                    $history->tick_id,
                                    $history->hist_message
                                );
                            }
                            ?>
                            </strong>
                        </div>
                        <?php 
                        if ( $type == 5 && ! empty( $history->hist_message )) :
                        ?>
                        <div class="iptrac-history-message">
                            <h4><?php _e( 'Message', 'wpiptrac' ); ?></h4>
                            <div class="iptrac-message-content">
                                <?php
                                echo $history->hist_message;
                                ?>
                            </div>
                        </div>
                        <?php 
                        endif;
                        ?>
                    </div>
                </li>
            <?php
            endforeach;
            ?>
            </ul>
        </div>
        <?php
        else :
        ?>
        <div class="iptrac-history-empty">
            <p class="ipadm-empty"><em><?php _e( 'Ticket histories not found', 'wpiptrac' ); ?></em></p>
        </div>
        <?php
        endif;
        ?>
        <div class="iptrac-add-file">
            <a id="iptrac-show-message-modal" href="#" class="ipadm-btn ipadm-btn-primary"><i class="fa fa-envelope"></i> Send Message</a>
        </div>
        
    </div>
</div>

                        </div>
                    </div>
                </div>

<div class="iptrac-modals-wrap">

    <div id="iptrac-ticket-modal" class="iptrac-modal" style="display: none;">
        <div class="iptrac-modal-inner">
            <div id="iptrac-ticket-modal-content" class="iptrac-modal-main">
            
                <div class="iptrac-modal-close">
                    <a class="iptrac-modal-close-link" href="#">x</a>
                </div>
                
                <h3 class="iptrac-modal-title"><?php _e( 'Edit Ticket', 'wpiptrac' ); ?></h3>
                <div class="iptrac-modal-content">

<form id="iptrac-form-send-ticket" action="" method="post">

    <input type="hidden" name="ticket_id" id="value-ticket-id" value="<?php echo $ticket->tick_id; ?>" />
    <input type="hidden" name="user_type" class="value-user-type" value="1" />

    <div class="ipadm-form-main iptrac-onecolumn">
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-summary"><?php _e( 'Summary', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <input type="text" class="ipadm-input ipadm-input-widest" id="input-summary" name="summary" value="<?php echo $ticket->tick_summary; ?>" />
            </div>
        </div>
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-description"><?php _e( 'Description', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <?php
                $content = $ticket->tick_desc;
                wp_editor( $content, 'description', array( 
                    'editor_height' => 200,
                )); 
                ?>
            </div>
        </div>
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-product"><?php _e( 'Product', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <select name="product" id="input-product">
                    <?php 
                    $selectProd = $ticket->prod_id;
                    if ( $products = $model->getProducts() ) {
                        foreach( $products as $product ) 
                        {
                            $sltd = '';
                            if ( $selectProd == $product->prod_id ) {
                                $sltd = ' selected="selected"';
                            }
                            echo '<option value="' . $product->prod_id . '"' . $sltd . '>' . $product->prod_title . '</option>';
                        }
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-version"><?php _e( 'Version', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <select name="version" id="input-version">
                    <?php 
                    if ( ! empty( $selectProd )) 
                    {
                        $select = $ticket->vers_id;
                        if ( $versions = $model->getVersions( $selectProd ) ) 
                        {
                            foreach( $versions as $version ) 
                            {
                                $sltd = '';
                                if ( $select == $version->vers_id ) {
                                    $sltd = ' selected="selected"';
                                }
                                echo '<option value="' . $version->vers_id . '"' . $sltd . '>' . $version->vers_label . '</option>';
                            }
                        }
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-type"><?php _e( 'Type', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <select name="type" id="input-type">
                    <?php 
                    $select = $ticket->type_id;
                    if ( $types = $model->getTypes() ) {
                        foreach( $types as $type ) 
                        {
                            $sltd = '';
                            if ( $select == $type->type_id ) {
                                $sltd = ' selected="selected"';
                            }
                            echo '<option value="' . $type->type_id . '"' . $sltd . '>' . $type->type_label . '</option>';
                        }
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div id="iptrac-field-attachment" class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-focus"><?php _e( 'Focus', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <select name="focus" id="input-focus">
                    <?php 
                    $select = $ticket->focus_id;
                    if ( $focuses = $model->getFocuses() ) {
                        foreach( $focuses as $focus ) 
                        {
                            $sltd = '';
                            if ( $select == $focus->focus_id ) {
                                $sltd = ' selected="selected"';
                            }
                            echo '<option value="' . $focus->focus_id . '"' .$sltd . '>' . $focus->focus_label . '</option>';
                        }
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-label">
                <label for="input-staff"><?php _e( 'Staff', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
            </div>
            <div class="ipadm-field">
                <select name="staff" id="input-staff">
                    <?php 
                    $select    =  $ticket->staff_id;
                    $userQuery = new WP_User_Query( array( 'role' => 'Administrator' ) );
                    if ( $users = $userQuery->get_results() ) {
                        foreach( $users as $user ) {
                            $name = '';
                            if ( ! empty( $user->user_name )) {
                                $name = $user->user_name;
                            }
                            elseif ( ! empty( $user->user_nicename )) {
                                $name = $user->user_nicename;
                            }
                            elseif ( ! empty( $user->user_login )) {
                                $name = $user->user_login;
                            }
                            $sltd = '';
                            if ( $select == $user->ID ) {
                                $sltd = ' selected="selected"';
                            }
                            echo '<option value="' . $user->ID . '"' .$sltd . '>' . $name . '</option>';
                        }
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div class="ipadm-btn-wrap">
            <input type="submit" id="iptrac-edit-ticket" name="do_edit_ticket" class="ipadm-btn ipadm-btn-primary ipadm-btn-large" value="Edit ticket" />
        </div>
        
    </div>

</form>

                </div>
            </div>
        </div>
    </div>

    <div id="iptrac-add-modal" class="iptrac-modal" style="display: none;">
        <div class="iptrac-modal-inner">
            <div id="iptrac-add-att-content" class="iptrac-modal-main">
            
                <div class="iptrac-modal-close">
                    <a class="iptrac-modal-close-link" href="#">x</a>
                </div>
                
                <h3 id="iptrac-attach-add-title" class="iptrac-modal-title"><?php _e( 'Add Attachment', 'wpiptrac' ); ?></h3>
                <h3 id="iptrac-attach-edit-title" class="iptrac-modal-title" style="display:none;"><?php _e( 'Edit Attachment', 'wpiptrac' ); ?></h3>
                
                <div class="iptrac-modal-content">
                    
                    <div class="ipadm-main">
                        <div class="ipadm-form-wrap">
                            <form id="iptrac-form-add-attach" action="" method="post" enctype="multipart/form-data">
            
                                <input type="hidden" id="value-ticket-id" name="ticket_id" value="<?php echo $ticket->tick_id; ?>" />
                                <input type="hidden" id="value-attach-id" name="attach_id" value="0" />
                                
                                <div class="fields">
                                    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                                        <div class="ipadm-label">
                                            <label for="input-attach-file"><?php _e( 'File', 'wpiptrac' ); ?> <em class="ipadm-required">(<?php _e( 'required', 'wpiptrac' ); ?>)</em></label>
                                        </div>
                                        <div class="ipadm-field">
                                            <div class="iptrac-file-input">
                                                <input type="file" name="attach_file" id="input-attach-file" />
                                            </div>
                                        </div>
                                    </div>
                                    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                                        <div class="ipadm-label">
                                            <label for="input-file-title"><?php _e( 'Title', 'wpiptrac' ); ?></label>
                                        </div>
                                        <div class="ipadm-field">
                                            <input type="text" class="ipadm-input ipadm-input-widest" name="file_title" id="input-file-title" value="" />
                                        </div>
                                    </div>
                                    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                                        <div class="ipadm-label">
                                            <label for="input-file-desc"><?php _e( 'Description', 'wpiptrac' ); ?></label>
                                        </div>
                                        <div class="ipadm-field">
                                            <textarea class="ipadm-input ipadm-input-widest" id="input-file-desc" name="file_desc" rows="8"></textarea>
                                        </div>
                                    </div>
                                </div>
                                
                                <div class="ipadm-btn-wrap iptrac-form-actions">
                                    <input type="submit" class="ipadm-btn ipadm-btn-primary" id="iptrac-do-add-attach" name="do_add_attach" value="Add attachment" />
                                    <input type="submit" class="ipadm-btn ipadm-btn-primary" id="iptrac-do-edit-attach" name="do_edit_attach" value="Edit attachment" style="display: none;" />
                                    <a href="#" class="ipadm-btn ipadm-btn-default iptrac-modal-cancel">Cancel</a>
                                </div>
                
                            </form>
                        </div>
                    </div>
                    
                </div>
                
            </div>
        </div>
    </div>

    <div id="iptrac-msg-modal" class="iptrac-modal" style="display: none;">
        <div class="iptrac-modal-inner">
            <div id="iptrac-msg-modal-content" class="iptrac-modal-main">
            
                <div class="iptrac-modal-close">
                    <a class="iptrac-modal-close-link" href="#">x</a>
                </div>
                
                <h3 class="iptrac-modal-title"><?php _e( 'Send Message', 'wpiptrac' ); ?></h3>
                
                <div class="iptrac-modal-content">
                
<form id="iptrac-form-send-msg" action="" method="post">

    <input type="hidden" name="ticket_id" id="value-ticket-id" value="<?php echo $ticket->tick_id; ?>" />
    <input type="hidden" name="user_type" class="value-user-type" value="1" />

    <div class="ipadm-form-main iptrac-onecolumn">
        
        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
            <div class="ipadm-field" style="margin-left: 0;">
                <?php
                $content = '';
                wp_editor( $content, 'message', array( 
                    'editor_height' => 500,
                )); 
                ?>
            </div>
        </div>
        
        <div class="ipadm-btn-wrap">
            <input type="submit" id="iptrac-send-message" name="do_send_message" class="ipadm-btn ipadm-btn-primary ipadm-btn-large" value="Send message" />
        </div>
    </div>
</form>
                </div>
            </div>
        </div>
    </div>
    
    <div id="iptrac-modal-loader-overlay" style="display:none;">
        <div id="iptrac-modal-loader"></div>
    </div>

    <div id="iptrac-modal-message-overlay" style="display:none;">
        <div id="iptrac-modal-message"></div>
    </div>
</div>
            </div>
        <?php 
        }
        
    }
    
}