<?php
if ( ! class_exists( 'IPTrac_History' )) {

    /**
     * Class for processing history
     */
    class IPTrac_History
    {
        /**
         * Save send ticket history
         *
         * @param  int    $tickId
         * @param  string $summary
         * @return int|false
         */
        public function sendTicket( $tickId, $summary )
        {
            global $user_ID;
            
            $model    = new IPTrac_Model();
            $secrret  = '@wp_iptrac_history_$#123@';
            $toInsert = array(
                'tick_id'         => $tickId,
                'user_id'         => $user_ID,
                'hist_date'       => date( 'c' ),
                'hist_user_type'  => 2,
                'hist_type'       => 1,
                'hist_token'      => md5( time() + $secret ),
                'hist_message'    => $summary,
            );
            $result = $model->insertHistory( $toInsert );
            return $result;
        }
        
        /**
         * Save accept ticket history
         *
         * @param  object $ticket
         * @return int|false
         */
        public function acceptTicket( $ticket )
        {
            global $user_ID;
            
            $model    = new IPTrac_Model();
            $secrret  = '@wp_iptrac_history_$#123@';
            $toInsert = array(
                'tick_id'         => $ticket->tick_id,
                'user_id'         => $user_ID,
                'hist_date'       => date( 'c' ),
                'hist_user_type'  => 1,
                'hist_type'       => 2,
                'hist_token'      => md5( time() + $secret ),
                'hist_message'    => $ticket->tick_summary,
            );
            $result = $model->insertHistory( $toInsert );
            return $result;
        }
        
        /**
         * Save reopen ticket history
         *
         * @param  object $ticket
         * @param  int    $userType
         * @return int|false
         */
        public function reopenTicket( $ticket, $userType )
        {
            global $user_ID;
            
            $model    = new IPTrac_Model();
            $secrret  = '@wp_iptrac_history_$#123@';
            $toInsert = array(
                'tick_id'         => $ticket->tick_id,
                'user_id'         => $user_ID,
                'hist_date'       => date( 'c' ),
                'hist_user_type'  => $userType,
                'hist_type'       => 3,
                'hist_token'      => md5( time() + $secret ),
                'hist_message'    => $ticket->tick_summary,
            );
            $result = $model->insertHistory( $toInsert );
            return $result;
        }
        
        /**
         * Save close ticket history
         *
         * @param  object $ticket
         * @param  int    $userType
         * @return int|false
         */
        public function closeTicket( $ticket, $userType )
        {
            global $user_ID;
            
            $model    = new IPTrac_Model();
            $secrret  = '@wp_iptrac_history_$#123@';
            $toInsert = array(
                'tick_id'         => $ticket->tick_id,
                'user_id'         => $user_ID,
                'hist_date'       => date( 'c' ),
                'hist_user_type'  => $userType,
                'hist_type'       => 4,
                'hist_token'      => md5( time() + $secret ),
                'hist_message'    => $ticket->tick_summary,
            );
            $result = $model->insertHistory( $toInsert );
            return $result;
        }
        
        /**
         * Save send message history
         *
         * @param  int    $tickId
         * @param  int    $userType
         * @return int|false
         */
        public function sendMessage( $tickId, $userType )
        {
            global $user_ID;
            
            $model    = new IPTrac_Model();
            $secrret  = '@wp_iptrac_history_$#123@';
            $toInsert = array(
                'tick_id'         => $tickId,
                'user_id'         => $user_ID,
                'hist_date'       => date( 'c' ),
                'hist_user_type'  => $userType,
                'hist_type'       => 5,
                'hist_token'      => md5( time() + $secret ),
                'hist_message'    => mysql_real_escape_string( $_POST['message'] ),
            );
            $result = $model->insertHistory( $toInsert );
            return $result;
        }
        
        /**
         * Save upload file history
         *
         * @param  int    $tickId
         * @param  string $filename
         * @param  int    $userType
         * @return int|false
         */
        public function addFile( $tickId, $filename, $userType )
        {
            global $user_ID;
            
            $model    = new IPTrac_Model();
            $secrret  = '@wp_iptrac_history_$#123@';
            $toInsert = array(
                'tick_id'         => $tickId,
                'user_id'         => $user_ID,
                'hist_date'       => date( 'c' ),
                'hist_user_type'  => $userType,
                'hist_type'       => 6,
                'hist_token'      => md5( time() + $secret ),
                'hist_message'    => $filename,
            );
            $result = $model->insertHistory( $toInsert );
            return $result;
        }
        
        /**
         * Save delete file history
         *
         * @param  object $file
         * @param  int    $userType
         * @return int|false
         */
        public function deleteFile( $file, $userType )
        {
            global $user_ID;
            
            $model    = new IPTrac_Model();
            $secrret  = '@wp_iptrac_history_$#123@';
            $toInsert = array(
                'tick_id'         => $file->tick_id,
                'user_id'         => $user_ID,
                'hist_date'       => date( 'c' ),
                'hist_user_type'  => $userType,
                'hist_type'       => 7,
                'hist_token'      => md5( time() + $secret ),
                'hist_message'    => $file->post_name,
            );
            $result = $model->insertHistory( $toInsert );
            return $result;
        }
        
        /**
         * Save reject ticket history
         *
         * @param  object $ticket
         * @return int|false
         */
        public function rejectTicket( $ticket )
        {
            global $user_ID;
            
            $model    = new IPTrac_Model();
            $secrret  = '@wp_iptrac_history_$#123@';
            $toInsert = array(
                'tick_id'         => $ticket->tick_id,
                'user_id'         => $user_ID,
                'hist_date'       => date( 'c' ),
                'hist_user_type'  => 1,
                'hist_type'       => 8,
                'hist_token'      => md5( time() + $secret ),
                'hist_message'    => $ticket->tick_summary,
            );
            $result = $model->insertHistory( $toInsert );
            return $result;
        }
    }
}

